-- Warborg is Wargames playing on network
-- Copyright (C) 2011 Manuel De Girardi

-- This Program is Free Software: You Can Redistribute It and/or Modify
-- It Under The Terms of The GNU General Public License As Published By
-- The Free Software Foundation, Either Version 3 of The License, or
-- (at Your Option) Any Later Version.

-- This Program is Distributed in The Hope That It Will Be Useful,
-- But WITHOUT ANY WARRANTY; Without Even The Implied Warranty of
-- MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE.  See The
-- GNU General Public License for More Details.

-- You Should Have Received A Copy of The GNU General Public License
-- Along with This Program.  if not, See <Http://Www.Gnu.Org/Licenses/>.

with Gnat.Semaphores;
with Ada.Containers.Vectors;

package Warborg.Database is         
   
   
   function "=" (Left, Right : in Wopr_Type) return Boolean;
   
   package Wopr_Manager is new Ada.Containers.Vectors(Positive, Wopr_Type, "=");
   
   protected type Sgbd_Type is
      
      procedure Get_Wopr(Logname : in Logname_type;
			 Wopr : in out Wopr_Type;
			 Success : in out Boolean);
      procedure Add_Wopr(Logname : in Logname_type;
                     Wopr : in Wopr_Type;
                     Success : out boolean);
      procedure Get_Enemy(Logname : in Logname_Type;
                      Missiles : out Weapon_Manager.Vector);
      procedure Add_Missile(Logname : in Logname_Type;
                       Missile : in Missile_Type;
                       Success : out Boolean);
      procedure Launch_All(Logname : in Logname_Type);

   private
                  
      Allway   : Boolean := True;
      Woprs    : Wopr_Manager.Vector;
   end Sgbd_Type;
   
   Lock : Gnat.Semaphores.Binary_Semaphore(True,
					   Gnat.Semaphores.Default_Ceiling);   
end Warborg.Database;
