with Glib.Convert;
use Glib;
with Gtk.Text_Mark;       use Gtk.Text_Mark;
with Gtk.Text_Iter;       use Gtk.Text_Iter;
with Ada.Strings.Fixed;
use Ada.Strings;

with Gtk.Gentry;          use Gtk.Gentry;
with Gtk.Check_Button;    use Gtk.Check_Button;

with Gnat.Sha1;           use Gnat;


with Cairo.Pattern;       use Cairo.Pattern;
with Cairo.Png;           use Cairo.Png;

with Cairo.Surface;       use Cairo.Surface;

with Pango.Cairo;         use Pango.Cairo;

with Gdk.Cairo;           use Gdk.Cairo;

with Gtk.Style;           use Gtk.Style;

with Pango.Layout;        use Pango.Layout;


with Gtk.Scrolled_Window;               use Gtk.Scrolled_Window;

with Ada.Text_IO;--                       use Ada.Text_IO;

with System;                            use System;

with Glib.Error;                        use Glib.Error;

with Gtk.Action;                        use Gtk.Action;


with Gtk.Stock;                         use Gtk.Stock;

with Gtk.Window;                        use Gtk.Window;
with Gtk.Handlers;                      use Gtk.Handlers;
with Gtk.Widget;                        use Gtk.Widget;
with Gtk.Enums;                         use Gtk.Enums;

use Gtk;

with Warborg.Norad;                     use Warborg.Norad;
with Glib.Object;
with Glib.Glist;
package body Warborg.Xborg is
   
   
   All_Populations : Nation_Manager.Vector := Nation_Manager.Empty_Vector;		
   
   Charge_Spin_Min : constant Gdouble := 15.0;
   Charge_Spin_Max : constant Gdouble := 120.0;
   Charge_Spin_step : constant Gdouble := 15.0;
   
   Deamon_Delay     : Duration := 5.0;
   
   
   
   function To_Map_Coordonates(GPS_Coordonates : in Gps_Coordonates_Type) return Map_Coordonates_Type is
      
      Map_Coordonates : Map_Coordonates_Type;
   begin
      if Gps_Coordonates.Longitude.Degr_Lon >= 0.0 then
	 
	 Map_Coordonates.X := 
	   Max_X_Coordonate/2.0 + 
	   (((GPS_Coordonates.Longitude.Degr_Lon) * (3600.0 * Lon_unit)) +
	   ((GPS_Coordonates.Longitude.Minu_Lon) * (60.0 * Lon_Unit)) +
	   ((GPS_Coordonates.Longitude.Seco_Lon) * Lon_Unit));
      else
	 
	 Map_Coordonates.X := 
	   Max_X_Coordonate/2.0 - 
	   (((GPS_Coordonates.Longitude.Degr_Lon) * (3600.0 * Lon_unit)  * (-1.0)) +
	   ((GPS_Coordonates.Longitude.Minu_Lon) * (60.0 * Lon_Unit)) +
	   ((GPS_Coordonates.Longitude.Seco_Lon) * Lon_Unit));	 
     end if;
     
     if Gps_Coordonates.Latitude.Degr_Lat >= 0.0 then
	 	 
	 Map_Coordonates.Y := 
	   Max_Y_Coordonate/2.0 -
	   (((Gps_Coordonates.Latitude.Degr_Lat) * (3600.0 * Lat_unit)) +
	      ((Gps_Coordonates.Latitude.Minu_Lat) * (60.0 * Lat_Unit)) +
	      ((Gps_Coordonates.Latitude.Seco_Lat) * Lat_Unit));	 
      else
	 Map_Coordonates.Y := 
	   Max_Y_Coordonate/2.0 + 
	   (((Gps_Coordonates.Latitude.Degr_Lat) * (3600.0 * Lat_unit) * (-1.0)) +
	   ((Gps_Coordonates.Latitude.Minu_Lat) * (60.0 * Lat_Unit)) +
	   ((Gps_Coordonates.Latitude.Seco_Lat) * Lat_Unit));
	 
      end if;
      

      return Map_Coordonates;
   end To_Map_Coordonates;      
   
   
   -------------------------------------
   -- System functions specifications --
   -------------------------------------
   
   procedure Main_Quit (Action, Main_Window : System.Address);
   pragma Convention (C, Main_Quit);
   --  Called when Quit actions has been selected
   
   procedure login (Action, Main_Window : System.Address);
   pragma Convention (C, Login);
   --  Called when Login actions has been selected
   
   procedure logout (Action, Main_Window : System.Address);
   pragma Convention (C, Logout);
   --  Called when Logout actions has been selected
   
   procedure Start_New_Game (Action, Main_Window : System.Address);
   pragma Convention (C, Start_New_Game);
   --  Called when Start actions has been selected      
   
   procedure Set_algo (Action, Main_Window : System.Address);
   pragma Convention (C, Set_algo);
   --  Called when Algorithm actions has been selected
   
   procedure LertCon (Action, Main_Window : System.Address);
   pragma Convention (C, LertCon);
   --  Called when Lertcon actions has been selected
      
   --------------------
   -- Window define ---
   --------------------
   
   package Window_Cb is new Handlers.Callback (Gtk_Widget_Record);
   package Return_Window_Cb is new Handlers.Return_Callback
     (Gtk_Widget_Record, Boolean);
   
   --package Defcon_Timeout is
   --   new Gtk.Main.Timeout(Main_Window_Type);

   
   procedure Exit_Main (Object : access Gtk_Widget_Record'Class);
   --  Callbacks when the main window is killed
   function Delete_Event
     (Object : access Gtk_Widget_Record'Class) return Boolean;      
      
   procedure Zoom_In (Action, Main_Window : System.Address);
   pragma Convention (C, Zoom_In);
   --  Called when Zoom_In actions has been selected
   
   procedure Zoom_Out (Action, Main_Window : System.Address);
   pragma Convention (C, Zoom_Out);
   --  Called when Zoom_Out actions has been selected   
   
   procedure Automation_Install (Action, Main_Window : System.Address);
   pragma Convention (C, Automation_install);
   --  Called when Automation_Install actions has been selected
   
   procedure Automation_Remove (Action, Main_Window : System.Address);
   pragma Convention (C, Automation_Remove);
   --  Called when Automation_Remove actions has been selected   
   
   procedure About (Action, Main_Window : System.Address);
   pragma Convention (C, About);
   --  Called when About actions has been selected
   
   procedure License (Action, Main_Window : System.Address);
   pragma Convention (C, License);
   --  Called when License actions has been selected   

   
   procedure Zoom_In
     (Canvas : access Interactive_Canvas_Record'Class);
   procedure Zoom_Out
     (Canvas : access Interactive_Canvas_Record'Class);
   
   
   
   -- Item functions Specifications --
   
   procedure Add_Canvas_Link
     (Canvas : access Interactive_Canvas_Record'Class;
      Item1, Item2 : access Canvas_Item_Record'Class; Text : String := "");
   

   
         
   ---------------------------------------
   -- System functions Implementations. --
   ---------------------------------------
   
   -----------------------
   -- WOPR finalization --
   -----------------------
   
   procedure Finalize;
   
   procedure Finalize is
   begin
      Norad.Wopr.Logout;
      abort Norad.Wopr;
   end Finalize;
   
   -----------------
   --  Exit_Main  --
   -----------------

   procedure Exit_Main (Object : access Gtk_Widget_Record'Class) is
   begin
      Finalize;
      Destroy (Object);
      Gtk.Main.Main_Quit;
   end Exit_Main;

   ------------------
   -- Delete_Event --
   ------------------

   function Delete_Event
     (Object : access Gtk_Widget_Record'Class) return Boolean
   is
      pragma Unreferenced (Object);
   begin
      Finalize;
      --  We could return True to force the user to kill the window through the
      --  "Quit" button, as opposed to the icon in the title bar.
      return False;
   end Delete_Event;

   
   ---------------------
   --    Main Quit    --
   ---------------------
   
   procedure Main_Quit (Action, Main_Window : System.Address) is
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));
      
      
      pragma Unreferenced (Main_Window);
   begin
      Finalize;
      Gtk.Main.Main_Quit;
   end Main_Quit;
      
   
   
   --------------------------------------------
   -- Specific Item functions specifications --
   --------------------------------------------
   
   procedure Initialize_Wopr (Item   : access Display_Item_Record'Class;
			      Canvas : access Interactive_Canvas_Record'Class);
   
   procedure Initialize_Populations (Item   : access Display_Item_Record'Class;
				    Canvas : access Interactive_Canvas_Record'Class);
   
   procedure Initialize_target (Item   : access Display_Item_Record'Class;
				Canvas : access Interactive_Canvas_Record'Class);
   
   
   procedure Initialize_missile (Item   : access Display_Item_Record'Class;
				 Canvas : access Interactive_Canvas_Record'Class);
   
   procedure Initialize_enemy (Item   : access Display_Item_Record'Class;
			       Canvas : access Interactive_Canvas_Record'Class);
      

   procedure Add_Wopr_Item (Main_Window : access Main_Window_Record_type'Class) is

      Item : constant Display_Item := new Display_Item_Record;
   begin
      Initialize_wopr (Item, Main_Window.Canvas);
      --Add_Canvas_Link (Main_Window.Canvas, item, item, "WOPR");
      Put (Main_Window.Canvas, Item,
	   Gint(To_Map_Coordonates(Main_Window.Wopr.Gps_Coordonates).X),
	   Gint(To_Map_Coordonates(Main_Window.Wopr.Gps_Coordonates).Y));      

      Refresh_Canvas (Main_window.Canvas);
      Show_Item (Main_Window.Canvas, Item);
   end Add_Wopr_Item;

   
   procedure Add_Target(Main_window : access Main_Window_Record_Type'class;
			Source_X : Gint;
			Source_Y : Gint;
			Target_X : Gint;
			Target_Y : Gint;
			Text   : string) is
      Missile : constant Display_Item := new Display_Item_Record;
      cible : constant Display_Item := new Display_Item_Record;
   begin
      Initialize_Missile (Missile, Main_Window.canvas);
      Initialize_target (Cible, Main_Window.canvas);      
      --Add_Canvas_Link (Main_Window.Canvas, Missile, Cible, Text);
      Put (Main_Window.Canvas, Missile, Source_X, Source_Y);
      Refresh_Canvas (Main_Window.Canvas);
      Show_Item (Main_Window.Canvas, Missile);
      Put (Main_Window.Canvas, Cible, Target_X, Target_Y);
      Refresh_Canvas (Main_Window.Canvas);      
      Show_Item (Main_Window.Canvas, Cible);
   end Add_Target;
   
   
   procedure Add_Population(Main_window : access Main_Window_Record_Type'class;
			    Source_X : in Gint;
			    Source_Y : in Gint;
			    Name     : in string) is
      
      Population : constant Display_Item := new Display_Item_Record;

   begin
      Initialize_Populations (Population, Main_Window.canvas);
      
      --Add_Canvas_Link (Main_Window.Canvas, Population, Population, name);
      Put (Main_Window.Canvas, Population, Source_X, Source_Y);
      Refresh_Canvas (Main_Window.Canvas);
      Show_Item (Main_window.Canvas, Population);
      
   end Add_population;

   
   procedure Add_Enemy(Main_window : access Main_Window_Record_Type'class;
		       Source_X : in Gint;
		       Source_Y : in Gint;
		       target    : in string) is
      
      Population : constant Display_Item := new Display_Item_Record;

   begin
      Initialize_enemy (Population, Main_Window.canvas);

      --Add_Canvas_Link (Main_window.Canvas, Population, Population, target);
      Put (Main_Window.Canvas, Population, Source_X, Source_Y);
      Refresh_Canvas (Main_Window.Canvas);
      Show_Item (Main_window.Canvas, Population);
      
   end Add_Enemy;


   
   
   --------------------
   --    Draw WOPR   --
   --------------------
   procedure Draw_Wopr_With_population(Main_Window : access Main_Window_Record_Type'class) is
      
      
      Fraction : Gdouble := 0.0;            
      Success  : Boolean := False;
   begin            
      
      --  Add_Population(Main_Window,
      --  		     Gint(10),
      --  		     Gint(640),
      --  		     "Populations");
      
      --  Add_enemy(Main_Window,
      --  		Gint(10),
      --  		Gint(680),
      --  		"Enemy");
      
      --  Add_target(Main_Window,
      --  		 Gint(10),
      --  		 Gint(720),
      --  		 Gint(10),
      --  		 Gint(760),
      --  		 "Missile with target");
		 
      
      Add_Wopr_Item(Main_Window);      
      Set_fraction(Main_Window.Progress_Bar, 0.0);            
      Main_Window.Ouest_Population := 0;
      Main_Window.Est_Population := 0;
      Fraction := 0.0;
      Gtk_New(Main_Window.Nation_Buffer);
      
      if not Nation_Manager.Is_Empty(Main_Window.Wopr.Populations) then	 
	 --Gtk.Main.Grab_Add(Main_Window.Progress_Bar);
	 --Gtk.Main.Grab_Add(Main_Window.canvas);
         for I in 1..Nation_Manager.Last_Index(Main_Window.Wopr.populations) loop
	    Fraction := Gdouble(I)/(Gdouble(nation_Manager.Last_Index(Main_Window.Wopr.populations)));
            declare
               Nation : constant Nation_type := Warborg.Nation_Manager.Element(Main_Window.Wopr.populations, I);
	       Source_Map_Coordonates : constant Map_Coordonates_Type := To_Map_Coordonates(Nation.Gps_coordonates);	       
            begin
	       --Print_Missile(Missile);
	       case Side_Of(Nation.Gps_Coordonates) is
		  when Ouest =>
		     Main_Window.Ouest_Population := Main_Window.Ouest_Population + Nation.population;
		  when Est =>
		     Main_Window.Est_Population := Main_Window.Est_Population + Nation.population;
	       end case;
	       Add_Population(Main_Window,
			      Gint(Source_Map_Coordonates.X),
			      Gint(Source_Map_Coordonates.Y),
			      "");	       
	       --Name(1..Fixed.Index_Non_Blank(Name, Backward)
	       
	       Set_Fraction(Main_Window.Progress_Bar, Fraction);
	       --  Queue_Draw(Main_Window.Progress_Bar);
	       --Success := Gtk.Main.Main_Iteration;
	       
            end;
	    
         end loop;
	 --Gtk.main.Grab_remove(Main_Window.Progress_Bar);
	 --Gtk.main.Grab_remove(Main_Window.Canvas);
      end if;
      Set_Label(Main_Window.Populations_Ouest_Label, "Ouest :" & Long_Long_Integer'Image(Main_Window.Ouest_Population));
      Set_Label(Main_Window.Populations_Est_Label, "Est   :" & Long_Long_Integer'Image(Main_Window.Est_Population));
      
      
            
      
   end Draw_Wopr_With_population;

   
   
   procedure Draw_Enemy(Main_Window : access Main_Window_Record_Type'class) is
      Fraction : Gdouble := 0.0;            
      Success  : Boolean := False;
   begin
      
      Set_fraction(Main_Window.Progress_Bar, 0.0);            
      if not Weapon_Manager.Is_Empty(Main_Window.Wopr.Enemy) then
	 --Gtk.main.Grab_Add(Main_Window.Progress_Bar);
	 --Gtk.main.Grab_Add(Main_Window.canvas);
         for I in 1..Weapon_Manager.Last_Index(Main_Window.Wopr.Enemy) loop
	    Fraction := Gdouble(I)/(Gdouble(weapon_Manager.Last_Index(Main_Window.Wopr.enemy)));
	    	    
            declare
               Missile : constant Missile_type := Weapon_Manager.Element(Main_Window.Wopr.Enemy, I);
	       Source_Map_Coordonates : constant Map_Coordonates_Type := To_Map_Coordonates(Missile.Position);
	       --Target_Map_Coordonates : Map_Coordonates_Type := To_Map_Coordonates(Missile.target);
            begin
	       --Print_Missile(Missile);
	       
	       
		 
	       Add_enemy(Main_Window,
			 Gint(Source_Map_Coordonates.X),
			 Gint(Source_Map_Coordonates.Y),
			"");
	       --Gint(Target_Map_Coordonates.X),
	       --Gint(Target_Map_Coordonates.Y),
		  --Missile.charge);

	       Set_Fraction(Main_Window.Progress_Bar, Fraction);
	       
	       --Success :=Gtk.Main.Main_Iteration;	       
	 end;
	    
	    
         end loop;
	 --Gtk.main.Grab_remove(Main_Window.Progress_Bar);
	 --Gtk.main.Grab_remove(Main_Window.canvas);
      end if;
      
   
      
   end Draw_Enemy;
     
     
   procedure Draw_Weapons(Main_Window : access Main_Window_Record_Type'class) is
     Fraction : Gdouble := 0.0;            
      Success  : Boolean := False;
   begin
      Set_fraction(Main_Window.Progress_Bar, 0.0);            
      if not Weapon_Manager.Is_Empty(Main_Window.Wopr.Weapons) then
	 --Gtk.main.Grab_Add(Main_Window.Progress_Bar);
	 --Gtk.main.Grab_Add(Main_Window.canvas);
         for I in 1..Weapon_Manager.Last_Index(Main_Window.Wopr.Weapons) loop
	    Fraction := Gdouble(I)/(Gdouble(weapon_Manager.Last_Index(Main_Window.Wopr.weapons)));
	    
	    
	    
            declare
               Missile : constant Missile_type := Weapon_Manager.Element(Main_Window.Wopr.Weapons, I);
	       Source_Map_Coordonates : constant Map_Coordonates_Type := To_Map_Coordonates(Missile.Position);
	       Target_Map_Coordonates : constant Map_Coordonates_Type := To_Map_Coordonates(Missile.target);
            begin
	       --Print_Missile(Missile);
	       
               Add_target(Main_Window,
			  Gint(Source_Map_Coordonates.X),
			  Gint(Source_Map_Coordonates.Y),
			  Gint(Target_Map_Coordonates.X),
			  Gint(Target_Map_Coordonates.Y),
			  "");
	       Set_Fraction(Main_Window.Progress_Bar, Fraction);
	       
	       --Success :=Gtk.Main.Main_Iteration;
            end;
         end loop;
	 --Gtk.main.Grab_remove(Main_Window.Progress_Bar);
	 --Gtk.main.Grab_remove(Main_Window.canvas);
      end if;
      
      
      
   end Draw_Weapons;
   
   
   package Defcon_Timeout is
      new Glib.Main.Generic_Sources(Main_Window_Type);
   
   
   function Lertcon_callback(Main_Window : Object_Pointer) return Boolean is
   begin
      Lertcon(Null_address, To_Address(Main_Window));
      return True;
   end Lertcon_Callback;
   
   
   procedure Automation_Install (Action, Main_Window : System.Address) is
      
      --  Called when Automation_Install actions has been selected      
      Vbox      : Gtk_Vbox;
      Automation_Ok        : Gtk.Widget.Gtk_Widget;
      Automation_Cancel    : Gtk.Widget.Gtk_Widget;
      Automation_Dialog : Gtk_Dialog;      
      
      Charge          : Gtk_Spin_Button;
      Charge_Label    : Gtk_Label;
      Charge_Hbox     : Gtk_Hbox;
      
      Strategy          : Gtk_Spin_Button;
      Strategy_Label    : Gtk_Label;
      Strategy_Hbox     : Gtk_Hbox;
      
      Full_Automation   : Gtk_Check_Button;
   begin

      if To_Pointer(Main_Window).Wopr.Self_Autorized then
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Computer")), False);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Human")), True);
	 To_Pointer(Main_Window).Self_Is_Set := True;
	 
	 Gtk_New(Automation_Dialog, "Strategy Paramaters...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
	 Set_Deletable(Automation_Dialog, False);
	 Automation_Cancel := Gtk.Dialog.Add_Button(Automation_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
	 Automation_Ok := Gtk.Dialog.Add_Button(Automation_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
	 Set_Position(Automation_Dialog, Win_Pos_Center);
	 
	 Vbox := Get_Content_area(Automation_Dialog);
	 Gtk_New_hbox(Charge_Hbox);
	 Gtk_New(Charge_Label, "Charge max : ");
	 Gtk_New(Charge, Charge_Spin_min, Charge_Spin_max, Charge_Spin_step);
	 Set_value(Charge, Gdouble(To_Pointer(Main_Window).Automation.Charge_Max_Per_Missile));
	 Pack_Start(Charge_Hbox, Charge_Label, False, False, 2);
	 Pack_Start(Charge_Hbox, Charge, False, False, 2);
	 Pack_Start(Vbox, Charge_Hbox, False, False, 0);
	 
	 Gtk_New_hbox(Strategy_Hbox);
	 Gtk_New(Strategy_Label, "Offensive  : ");
	 Gtk_New(Strategy, Gdouble(Per_Cent_Type'First), Gdouble(Per_Cent_Type'Last), Gdouble(Per_Cent_Type'First));
	 Set_Value(Strategy, Gdouble(To_Pointer(Main_Window).Automation.Offensive_Strategy));
	 Pack_Start(Strategy_Hbox, Strategy_Label, False, False, 2);
	 Pack_Start(Strategy_Hbox, Strategy, False, False, 2);
	 Pack_Start(Vbox, Strategy_Hbox, False, False, 0);
	 
	 
	 Gtk_New(Full_Automation, "Full Automation");			
	 Set_Active(Full_Automation, To_Pointer(Main_Window).Automation.Full_Automation);
	 Set_Use_Action_Appearance(Full_Automation, True);
	 Pack_Start(Vbox, Full_automation);						
	 
     
	 
	 Show_All(Automation_Dialog);	    	    
	 case Gtk.Dialog.Run(Automation_Dialog) is	    	    
	    when Gtk.Dialog.Gtk_Response_Ok =>
	       
	       
	       To_Pointer(Main_Window).Automation.Full_Automation := Get_Active(Full_Automation);
	       To_Pointer(Main_Window).Automation.Offensive_strategy := Per_Cent_Type(Get_Value(Strategy));
	       To_Pointer(Main_Window).Automation.Charge_Max_Per_missile := charge_Type(Get_Value(charge));
	       
	       Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :");
	       Set_Text(To_Pointer(Main_Window).Charge_missiles_Label, "Charge Max   :" & Charge_type'Image(To_Pointer(Main_Window).Automation.Charge_Max_Per_missile));
	       Set_Text(To_Pointer(Main_Window).Strategy_label,        "Strategy     :" & float'Image(To_Pointer(Main_Window).Automation.Offensive_strategy));
	       
	       
	       Gtk.Dialog.Destroy(Automation_Dialog);
	       
	    when others =>
	       Gtk.Dialog.Destroy(Automation_Dialog);
	       
	 end case;      
	    
	 
	 
	       
	 To_Pointer(Main_Window).Timeout_Id := Defcon_timeout.Timeout_Add(3000, Lertcon_callback'Access, To_Pointer(Main_Window));
      end if;
   end Automation_Install;
      
      
   procedure Automation_Remove (Action, Main_Window : System.Address) is

      --  Called when Automation_Remove actions has been selected   
            
   begin
      
      To_Pointer(Main_Window).Self_Is_Set := False;
      --Gtk.Main.Timeout_Remove(To_Pointer(Main_Window).Timeout_Id);
      glib.Main.Remove(To_Pointer(Main_Window).Timeout_Id);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Computer")), True);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Human")), False);
   end Automation_Remove;
   
   procedure About (Action, Main_Window : System.Address) is

      --  Called when About actions has been selected
      
   begin
      
      null;
   end About;
   
   procedure License (Action, Main_Window : System.Address) is
      
      --  Called when License actions has been selected   
      
   begin
      
      null;
   end License;
   

   --------------------
   -- Start new Game
   --------------------         
   procedure Start_New_Game (Action, Main_Window : System.Address) is      
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));
      Vbox      : Gtk_Vbox;
      Ok        : Gtk.Widget.Gtk_Widget;
      cancel    : Gtk.Widget.Gtk_Widget;
      Degr_Lat : Gdouble := 0.0;
      Minu_Lat : Gdouble := 0.0;
      Seco_Lat : Gdouble := 0.0;
      Degr_Lon : Gdouble := 0.0;
      Minu_Lon : Gdouble := 0.0;
      Seco_Lon : Gdouble := 0.0;

      Success : Boolean;
      
      End_Iter : Gtk_Text_Iter;
      Top_Iter : Gtk_Text_Iter;
      
   begin      
      --Text_Io.Put_Line ("Action " & Get_Name (Act) & " is not implemented");
      
      
      
      Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);
      
      if not Success then
	 
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Dialog,
                 "Get Wopr coordonates",
                 Gtk_Window(To_Pointer(Main_Window)),
                 Gtk.dialog.modal);
         Ok := Gtk.Dialog.Add_Button(To_Pointer(Main_Window).Wopr_Window.Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
         Cancel := Gtk.Dialog.Add_Button(To_Pointer(Main_Window).Wopr_Window.Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
         Vbox := Get_Content_area(To_Pointer(Main_Window).Wopr_Window.Dialog);
	 
         Set_Position(To_Pointer(Main_Window).Wopr_Window.dialog, Win_Pos_Center);
	 	 
	 Gtk_New(To_Pointer(Main_Window).Wopr_Window.Degr_Lat, -90.0, 90.0, 1.0);
	 set_value(To_Pointer(Main_Window).Wopr_Window.Degr_Lat, 0.0);
	 Gtk_New(To_Pointer(Main_Window).Wopr_Window.Degr_Lon, -180.0, 180.0, 1.0);	 
	 set_value(To_Pointer(Main_Window).Wopr_Window.Degr_Lon, 0.0);
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Minu_Lat, -60.0, 60.0, 1.0);
	 set_value(To_Pointer(Main_Window).Wopr_Window.minu_Lat, 0.0);
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Seco_Lat, -60.0, 60.0, 1.0);
	 set_value(To_Pointer(Main_Window).Wopr_Window.seco_Lat, 0.0);
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Minu_Lon, -60.0, 60.0, 1.0);
	 set_value(To_Pointer(Main_Window).Wopr_Window.Minu_Lon, 0.0);
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Seco_Lon, -60.0, 60.0, 1.0);
	 set_value(To_Pointer(Main_Window).Wopr_Window.Seco_Lon, 0.0);
         
         Gtk_New_Hbox(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox);
         Gtk_New_Hbox(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox);
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Lat_Label, "Latitude  :");
         Gtk_New(To_Pointer(Main_Window).Wopr_Window.Lon_Label, "Longitude :");
         Gtk_New_Hbox(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox);
         Gtk_New_Hbox(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox, To_Pointer(Main_Window).Wopr_Window.Lat_Label);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox, To_Pointer(Main_Window).Wopr_Window.Degr_lat);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox, To_Pointer(Main_Window).Wopr_Window.Minu_lat);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lat_Hbox, To_Pointer(Main_Window).Wopr_Window.Seco_lat);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox, To_Pointer(Main_Window).Wopr_Window.Lon_Label);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox, To_Pointer(Main_Window).Wopr_Window.Degr_Lon);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox, To_Pointer(Main_Window).Wopr_Window.Minu_Lon);
         Pack_Start(To_Pointer(Main_Window).Wopr_Window.Lon_Hbox, To_Pointer(Main_Window).Wopr_Window.Seco_Lon);
         Pack_Start(Vbox, To_Pointer(Main_Window).Wopr_Window.Lat_Hbox);
         Pack_Start(Vbox, To_Pointer(Main_Window).Wopr_Window.Lon_Hbox);


         Show_All(vbox);
	 loop
	    case Gtk.Dialog.Run(To_Pointer(Main_Window).Wopr_Window.Dialog) is
	       when Gtk.Dialog.Gtk_Response_Ok    =>

		  Degr_Lat := Get_Value(To_Pointer(Main_Window).Wopr_Window.Degr_Lat);
		  Minu_Lat := Get_Value(To_Pointer(Main_Window).Wopr_Window.Minu_Lat);
		  Seco_Lat := Get_Value(To_Pointer(Main_Window).Wopr_Window.Seco_Lat);
		  Degr_Lon := Get_Value(To_Pointer(Main_Window).Wopr_Window.Degr_Lon);
		  Minu_Lon := Get_Value(To_Pointer(Main_Window).Wopr_Window.Minu_Lon);
		  Seco_Lon := Get_Value(To_Pointer(Main_Window).Wopr_Window.Seco_Lon);
	       
		  To_Pointer(Main_Window).Wopr.Gps_Coordonates.Longitude := (Float(Degr_Lon), Float(Minu_Lon), Float(Seco_Lon));
		  To_Pointer(Main_Window).Wopr.Gps_Coordonates.Latitude := (Float(Degr_Lat), Float(Minu_Lat), Float(Seco_Lat));
		  
		  begin
		     To_Pointer(Main_Window).Wopr.side := Side_Of(To_Pointer(Main_Window).Wopr.Gps_Coordonates);
		     --Text_Io.Put_Line("Xborg: creating wopr at  side : " & Side_Type'Image(To_Pointer(Main_Window).Wopr.Side));
		     Norad.Wopr.Create(To_Pointer(Main_Window).Wopr, Success);
		     if Success then			
			Gtk.Dialog.Destroy(To_Pointer(Main_Window).Wopr_Window.Dialog);
			exit;
		     end if;				  
		  exception
		     when Constraint_Error =>
			null;
			--Text_Io.Put_Line("Xborg: creating wopr at side : undecisive");
		  end;
	       when Gtk.Dialog.Gtk_Response_Cancel =>
		  Gtk.Dialog.Destroy(To_Pointer(Main_Window).Wopr_Window.Dialog);
		  exit;
	       when others =>
		  null;
	    end case;

	 end loop;
	 
	 
      end if;
      
      Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);
      
      if Success then
	 Clear(To_Pointer(Main_Window).Canvas);
	 Draw_Wopr_With_population(To_Pointer(Main_Window));
	 
	 
	 Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_1.png");
	 
	 Set_Text(To_Pointer(Main_Window).Destroyed_Wopr_Label, "Destroyed WOPR    : " & Natural'Image(To_Pointer(Main_Window).Wopr.Destroyed_Wopr));
	 Set_Text(To_Pointer(Main_Window).Earned_missiles_Label, "Earned Missiles        : " & Natural'Image(To_Pointer(Main_Window).Wopr.Earned_Missiles));
	 Set_Text(To_Pointer(Main_Window).Destroyed_Missiles_Label, "Destroyed Missiles  : " & Natural'Image(To_Pointer(Main_Window).Wopr.Destroyed_Missiles));      
	 
	 Set_Text(To_Pointer(Main_Window).Attack_Missiles_Label, "Offensive Missiles  : " & Natural'Image(To_Pointer(Main_Window).Offensive_Missiles));
	 Set_Text(To_Pointer(Main_Window).Enemy_missiles_Label, "Enemy Missiles       : " & Natural'Image(To_Pointer(Main_Window).Enemy_Missiles));
	 Set_Text(To_Pointer(Main_Window).Defense_missiles_Label, "Defense Missiles    : "& Natural'Image(To_Pointer(Main_Window).Defensive_Missiles));
	 
	 Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :" & Charge_Type'Image(To_Pointer(Main_Window).Wopr.Charge));	 
	 
	 --Norad.Wopr.Set_Algorithm(random);
	 --Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Random")), False);
	 
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Start")), False);
	 if (To_Pointer(Main_Window).Wopr.Self_Autorized) then
	    Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("ModeMenu")), True);
	    Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Computer")), True);
	    Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Human")), False);
	 end if;
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Human")), False);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Linear")), True);
	 --Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Genetic")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("AlgoMenu")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("AlertMenu")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_1")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_2")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_3")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_4")), True);
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_5")), True);
      
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(Lertcon_Type'first)(2..Lertcon_Type'Image(Lertcon_Type'first)'last))), false);	    
	 
	 Get_Start_iter(To_Pointer(Main_Window).Nation_Buffer, Top_Iter);
	 Get_End_iter(To_Pointer(Main_Window).Nation_Buffer, End_Iter);
	 Delete(To_Pointer(Main_Window).Nation_Buffer, Top_Iter, End_Iter);
	 Set_buffer(To_Pointer(Main_Window).Nation_text, To_Pointer(Main_Window).Nation_Buffer);
	 
	 All_Populations := To_Pointer(Main_Window).Wopr.Populations;
      end if;
   end Start_New_Game;
   
   -------------
   -- log in  --
   -------------
   
   procedure login (Action, Main_Window : System.Address) is
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));

      
      Hostname : String_Access := new String ' ("");
      Password : Sha1.Message_Digest := Sha1.Digest("");
      Logname  : String_Access := new String ' ("");
      Success  : Boolean := False;
      
      
      Login_Dialog : Gtk_Dialog;
      Ok        : Gtk.Widget.Gtk_Widget;
      cancel    : Gtk.Widget.Gtk_Widget;
      Vbox : Gtk_Vbox;
      Logname_Entry  : Gtk_Gentry;
      hostname_Entry : Gtk_Gentry;
      Passwd_Entry   : Gtk_Gentry;
      
      Entry_Label : Gtk_Label;
      Entry_Hbox  : Gtk_Hbox;
      
   begin
      
      --Put_Line ("Action " & Get_Name (Act) & " was activated");
      
      Gtk_New(Login_Dialog, "Login", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);

		  
      Ok := Gtk.Dialog.Add_Button(Login_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
      Cancel := Gtk.Dialog.Add_Button(Login_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
      
      Vbox := Get_Content_area(Login_Dialog);
      Set_Position(Login_Dialog, Win_Pos_Center);
      Gtk_New(Hostname_Entry);
      Gtk_New(Entry_Label, "Hostname : ");
      Gtk_New_Hbox(Entry_Hbox);
      Pack_Start(Entry_Hbox, Entry_label);
      Pack_Start(Entry_Hbox, Hostname_Entry);
      Pack_Start(Vbox, Entry_Hbox);
      Gtk_New(Logname_Entry);
      Gtk_New(Entry_Label, "Logname  : ");
      Gtk_New_Hbox(Entry_Hbox);
      Pack_Start(Entry_Hbox, Entry_label);
      Pack_Start(Entry_Hbox, Logname_Entry);
      Pack_Start(Vbox, Entry_Hbox);
      Gtk_New(passwd_Entry);
      Gtk_New(Entry_Label, "Password : ");
      Gtk_New_Hbox(Entry_Hbox);
      Pack_Start(Entry_Hbox, Entry_label);
      Set_Visibility(Passwd_Entry, False);
      Pack_Start(Entry_Hbox, passwd_Entry);
      Pack_Start(Vbox, Entry_Hbox);
      
      Show_All(Login_Dialog);
      loop
	 case Gtk.Dialog.Run(Login_Dialog) is
	    when Gtk.Dialog.Gtk_Response_Ok =>	    
	       Hostname := new String ' (Get_Text(Hostname_Entry));
	       Logname := new String ' (Get_Text(Logname_Entry));
	       if Logname.all /= "" then
		  password := Sha1.digest(Get_Text(Passwd_Entry));
		  Norad.Wopr.login(Hostname.all, Logname.all, Password, success);
		  if Success then
		     Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Login")), False);
		     Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Logout")), True);
		     Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Start")), True);
		     Gtk.Dialog.Destroy(Login_Dialog);
		     exit;
		  end if;
	       end if;
	    when Gtk.Dialog.Gtk_Response_Cancel =>
	       Gtk.Dialog.Destroy(Login_Dialog);
	       exit;
	    when others =>
	       null;
	 end case;
      end loop;
   end login;
   
   -------------
   -- log in  --
   -------------
   
   procedure logout (Action, Main_Window : System.Address) is
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));

      
   begin
      
      --Put_Line ("Action " & Get_Name (Act) & " was activated");
      
      Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_5.png");                  
      
      Set_Text(To_Pointer(Main_Window).Populations_Ouest_Label, "");      
      Set_Text(To_Pointer(Main_Window).Populations_Est_Label, "");      
      
      Clear(To_Pointer(Main_Window).Canvas);
      
      Set_Text(To_Pointer(Main_Window).Destroyed_Wopr_Label, "");
      Set_Text(To_Pointer(Main_Window).Earned_missiles_Label, "");
      Set_Text(To_Pointer(Main_Window).Destroyed_Missiles_Label, "");
      
      Set_Text(To_Pointer(Main_Window).Attack_Missiles_Label, "");
      Set_Text(To_Pointer(Main_Window).Enemy_missiles_Label, "");
      Set_Text(To_Pointer(Main_Window).Defense_missiles_Label, "");
      
      
      
      
      
      Norad.Wopr.Logout;      
      
      Automation_Remove(Null_Address, Main_Window);
      
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Login")), True);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Logout")), False);      
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Start")), False);
      
      for I in Lertcon_Type'Range loop	 
	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), False);
      end loop;      
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("AlertMenu")), False);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("ModeMenu")), False);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Computer")), False);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Human")), False);
      Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("AlgoMenu")), False);
      
   end logout;
   
   
   procedure Set_algo (Action, Main_Window : System.Address) is
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));

                  
   begin
      --Put_Line ("Action " & Get_Name (Act)  & " was activated");
      if Get_Name (Act) = "Linear" then
	 
      	 Norad.Wopr.Set_Algorithm(Linear);
      	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Random")), True);
      	 --Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Genetic")), True);
      	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Linear")), False);
	 
      --  elsif Get_Name (Act) = "Genetic" then
	 
      --  	 Norad.Wopr.Set_Algorithm(Genetic);
	 
      --  	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Genetic")), False);
      --  	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Linear")), True);
      --  	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Random")), True);
      elsif Get_Name (Act) = "Random" then
	 
      	 Norad.Wopr.Set_Algorithm(Random);
      	 --Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Genetic")), True);
      	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Linear")), True);
      	 Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Random")), False);
	 
      end if;
   end Set_algo;
   
   
   
   procedure Game_Over (Main_Window : in Object_Pointer) is
      
      Ok_dialog : Gtk_dialog;
      Ok        : Gtk_Widget;
      
   begin
      Text_Io.Put(Character'Val(7));
      delay 0.2;
      Text_Io.Put(Character'Val(7));
      delay 0.2;
      Text_Io.Put(Character'Val(7));
      delay 0.2;
      Text_Io.Put(Character'Val(7));
      
      
      Automation_Remove(Null_Address, To_Address(Main_Window));
      
      
      for I in Lertcon_Type'Range loop	 
	 Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), True);
      end loop;
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_" & Lertcon_Type'Image(Lertcon_Type'first)(2..Lertcon_Type'Image(Lertcon_Type'first)'last))), false);	    
      Set_Sensitive(Get_Action(Main_Window.Actions, ("AlertMenu")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("AlgoMenu")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("ModeMenu")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Computer")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Human")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Start")), True);
      
      
      Gtk.Dialog.Gtk_New(Ok_Dialog, "Game over", Gtk_Window(Main_Window), Gtk.dialog.modal);
      
      Ok := Gtk.Dialog.Add_Button(Ok_Dialog, "OK", Gtk.Dialog.Gtk_Response_Ok);

      Set_Default_Size(Ok_Dialog, 150, 50);
      case Gtk.Dialog.Run(Ok_Dialog) is
         when Gtk.Dialog.Gtk_Response_Ok =>
            Gtk.Dialog.Destroy(Ok_Dialog);
         when others =>
            null;
      end case;
   end Game_Over;         
   
   type Missile_Unit_Type is
      record
	 Armed_Check     : Gtk_Check_Button;
         Degr_Lat : Gtk_Spin_Button;
         Minu_Lat : Gtk_Spin_Button;
         Seco_Lat : Gtk_Spin_Button;
         Degr_Lon : Gtk_Spin_Button;
         Minu_Lon : Gtk_Spin_Button;
         Seco_Lon : Gtk_Spin_Button;
	 Charge          : Gtk_Spin_Button;
      end record;

   
   use Weapon_Manager;
   
	    
   procedure LertCon (Action, Main_Window : System.Address) is
      
      
      Stub : Gtk_Action_Record;
      Act : constant Gtk_Action := Gtk_Action(Glib.Object.Get_User_Data (Action, stub));
            
      Alert : Lertcon_Type;            
      
      Wait_Dialog : Gtk_Dialog;
      cancel    : Gtk.Widget.Gtk_Widget;
      
      Success : Boolean := False;
      
      -- Defcon 5 dialog --            
      Charge_Max : Charge_Type := Charge_Type'First;
      Target_Max : natural := 1;
      Search_Dialog : Gtk_Dialog;      
      Search_Cancel    : Gtk.Widget.Gtk_Widget;
      Search_Ok        : Gtk.Widget.Gtk_Widget;      
      Charge          : Gtk_Spin_Button;
      Charge_Label    : Gtk_Label;
      Charge_Hbox     : Gtk_Hbox;
      Max_Label       : Gtk_Label;
      Max_Entry       : Gtk_Gentry;
      Max_Hbox        : Gtk_Hbox;
      Vbox            : Gtk_Vbox;
      
      -- Defcon 4/2 Armament validation
      Armament_Dialog : Gtk_Dialog;
      Armament_Cancel    : Gtk.Widget.Gtk_Widget;
      Armament_Ok        : Gtk.Widget.Gtk_Widget;      
      
      Fraction : Gdouble := 0.0;            
   begin
      if not (To_Pointer(Main_Window).Wopr.Self_Autorized and To_Pointer(Main_Window).Self_Is_Set) then
      	 --Put_Line ("Action " & Get_Name (Act)  & " was activated");
      	 for I in Lertcon_Type'Range loop
      	    if (Get_Name (Act) = "Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last)) then
      	       Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), false);
      	       Alert := I;
      	    else
      	       Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), True);
      	    end if;
      	 end loop;
      else
      	 for I in Lertcon_Type'Range loop
      	    if (("Defcon_" & Lertcon_Type'Image(To_Pointer(Main_Window).Current_Lertcon)(2..Lertcon_Type'Image(To_Pointer(Main_Window).Current_Lertcon)'last)) = ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))) then
      	       Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), false);
      	       Alert := I;
      	    else
      	       Set_Sensitive(Get_Action(To_Pointer(Main_Window).Actions, ("Defcon_" & Lertcon_Type'Image(I)(2..Lertcon_Type'Image(I)'last))), True);
      	    end if;
      	 end loop;
      	 Alert := To_Pointer(Main_Window).Current_Lertcon;
      end if;
      --  --Put_Line("Defcon : " & Lertcon_Type'Image(Alert));      
      Gtk_New(Wait_Dialog, "Please, Wait...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
      Set_Deletable(Wait_Dialog, False);
      Cancel := Gtk.Dialog.Add_Button(wait_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
      Set_Response_Sensitive(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel, false);
      Set_Position(Wait_Dialog, Win_Pos_Center);
      
      case Alert is
      	 when 1 =>
	    
	    Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_1.png");
	    
	    
	    declare
	       
	       
	       task Deamon is
	       end Deamon;
	       
	       task body Deamon is		  
	       begin
		  null; -- Launch -- reset system.	  
		  --Text_Io.Put_Line("Defcon 1 Lauch all");
		  Norad.Wopr.launch(To_Pointer(Main_Window).Wopr, Success);
		  --if Success then
		  --Text_Io.Put_Line("Defcon 1 get wopr");
		  Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);
		  --end if;
		  --Text_Io.Put_Line("Defcon 1 success");
		  if Success then
		     if not Weapon_Manager.Is_Empty(To_Pointer(Main_Window).Wopr.Weapons) then
			--Text_Io.Put_Line("Defcon 1 Weapon not empty");
			declare
			   Tmp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;		
			begin
			   for Index in 1..Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons) loop
			      declare
				 Missile : Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Weapons, index);
				 Buffer : constant Gps_Coordonates_Type := Missile.Target;
			      begin
				 Missile.target := Missile.Position;
				 Missile.Position := Buffer;
				 Tmp := Tmp & Missile;
			      end;
			      
			   end loop;
			   --Text_Io.Put_Line("Defcon 1 Weapon end loop");
			   Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Weapons);
			   To_Pointer(Main_Window).Wopr.Weapons := To_Pointer(Main_Window).Wopr.Weapons & Tmp;
			end;			
			
		     end if;
		     Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :" & Charge_Type'Image(To_Pointer(Main_Window).Wopr.Charge));

		  end if;
		  To_Pointer(Main_Window).Offensive_Missiles := 0;
		  To_Pointer(Main_Window).Enemy_Missiles := 0;
		  To_Pointer(Main_Window).Defensive_Missiles := 0;		  
		  delay Deamon_delay;
		  Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
	       end Deamon;	       
	    begin
	       Show_All(Wait_Dialog);                        
	       case Gtk.Dialog.Run(Wait_Dialog) is
		  when others =>
		     Gtk.Dialog.Destroy(Wait_Dialog);
	       end case;
	    end;	    
	    
	    if Success then
	       
	       
	       
	       declare
		  Saved_Populations : Nation_Manager.Vector := Nation_Manager.Empty_Vector;		
		  End_Iter : Gtk_Text_Iter;
		  Top_Iter : Gtk_Text_Iter;
		  Success  : Boolean := False;
		  Mark : Gtk.Text_Mark.Gtk_Text_Mark;
	       begin
		  
		  
		  if not Nation_Manager.Is_Empty(All_Populations) then	 
		     --Gtk.Main.Grab_Add(Main_Window.Progress_Bar);
		     --Gtk.Main.Grab_Add(Main_Window.canvas);
		     for I in 1..Nation_Manager.Last_Index(All_Populations) loop
			Fraction := Gdouble(I)/(Gdouble(nation_Manager.Last_Index(All_Populations)));
			declare
			   Nation : constant Nation_type := Warborg.Nation_Manager.Element(All_Populations, I);
			   Done : Boolean := False;
			   Success : Boolean := False;
			begin
			   
			   if not Nation_Manager.Is_Empty(To_Pointer(Main_Window).Wopr.Populations) then	 
			      --Gtk.Main.Grab_Add(To_Pointer(Main_Window).Progress_Bar);
			      --Gtk.Main.Grab_Add(To_Pointer(Main_Window).canvas);
			      for I in 1..Nation_Manager.Last_Index(To_Pointer(Main_Window).Wopr.populations) loop
				 
				 declare
				    local : constant Nation_type := Warborg.Nation_Manager.Element(To_Pointer(Main_Window).Wopr.populations, I);			
				 begin
				    
				    if Nation.Name = Local.Name then
				       Done := True;
				       exit;
				    end if;
				    
				    
				    
				 end;
				 
			      end loop;
			      
			      
			      --Gtk.main.Grab_remove(To_Pointer(Main_Window).Progress_Bar);
			      --Gtk.main.Grab_remove(To_Pointer(Main_Window).Canvas);
			   end if;
			   
			   if Done then
			      Nation_Manager.Insert(Saved_Populations, 1, Nation);
			   else
			      To_Pointer(Main_Window).Nation_Buffer := Get_Buffer(To_Pointer(Main_Window).Nation_Text);
			      Get_Start_iter(To_Pointer(Main_Window).Nation_Buffer, Top_Iter);
			      Get_End_iter(To_Pointer(Main_Window).Nation_Buffer, End_Iter);
			      Set_text(To_Pointer(Main_Window).Nation_Buffer, Get_text(To_Pointer(Main_Window).Nation_Buffer, Top_Iter, End_Iter) & Glib.Convert.Locale_to_Utf8(Nation.Name & Character'Val(10)));
			      Set_buffer(To_Pointer(Main_Window).Nation_text, To_Pointer(Main_Window).Nation_Buffer);
			      Get_End_iter(To_Pointer(Main_Window).Nation_Buffer, End_Iter);
			      Mark := Create_Mark(To_Pointer(Main_Window).Nation_Buffer, Where => End_Iter);
			      Scroll_To_Mark(To_Pointer(Main_Window).Nation_text, Mark, 0.0, False, 1.0, 1.0);
			   end if;
			   
			   
			   
			   
			   
			   Set_Fraction(To_Pointer(Main_Window).Progress_Bar, Fraction);
			   --  Queue_Draw(To_Pointer(Main_Window).Progress_Bar);
			   --Success := Gtk.Main.Main_Iteration;
			   
			end;
			
		     end loop;
		     
		     All_Populations := Saved_Populations;
		     
		  end if;
		  --Gtk.main.Grab_remove(To_Pointer(Main_Window).Progress_Bar);
		  --Gtk.main.Grab_remove(To_Pointer(Main_Window).Canvas);
	       end;
	    end if;
	    
	    Clear(To_Pointer(Main_Window).Canvas);	       	       
	    Draw_Wopr_With_population(To_Pointer(Main_Window));	    
      	 when 2 =>	    	    
	    
	    
	    Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_2.png");	    	    	    
	    Clear(To_Pointer(Main_Window).Canvas);
	    Draw_Wopr_With_population(To_Pointer(Main_Window));
	    Draw_weapons(To_Pointer(Main_Window));	    

	    	    
	    Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Weapons);
	    
	    if (To_Pointer(Main_Window).Wopr.Self_Autorized and To_Pointer(Main_Window).Self_Is_Set) and then To_Pointer(Main_Window).Automation.Full_Automation then
	       Charge_Max := To_Pointer(Main_Window).Automation.Charge_Max_Per_missile;
	       Target_Max := Natural(To_Pointer(Main_Window).Wopr.Charge/ Charge_Max);
	       begin						
		  if not Weapon_Manager.Is_Empty(To_Pointer(Main_Window).Wopr.Enemy) then
		     declare
			Temp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;
			Count : Natural := 0;
		     begin
			for Index in 1..Weapon_Manager.Last_index(To_Pointer(Main_Window).Wopr.Enemy) loop
			   
			   declare
			      Missile : Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Enemy, Index);
			      Buffer : constant Gps_Coordonates_Type := Missile.Position;
			   begin
			      exit when count = Target_Max;
			      Missile.Position:= Missile.Target;
			      Missile.Target := Buffer;
			      
			      Insert(Temp, Last_Index(Temp) + 1, Missile);
			      Count := Count + 1;
			      
			      
			   end;
			   
			end loop;
			
			To_Pointer(Main_Window).Wopr.Weapons := Temp;
			To_Pointer(Main_Window).Defensive_Missiles := 
			  Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons));
			
		     end;				    

		     
		     
		     declare
		     
		     
			task Deamon is
			end Deamon;
			
			task body Deamon is				    
			begin
			   
			   null; -- Defensive Armament -- target validation (list charge per missile);	    
			   Norad.Wopr.armament(To_Pointer(Main_Window).Wopr, Success);	    						
			   
			   --Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);
			   
			   To_Pointer(Main_Window).Defensive_Missiles := 
			     Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons));		
			   delay Deamon_delay;
			   Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
			end Deamon;	       
		     begin
			Show_All(Wait_Dialog);
			case Gtk.Dialog.Run(Wait_Dialog) is
			   when others =>
			      Gtk.Dialog.Destroy(Wait_Dialog);
			end case;
		     end;
		  end if;
		  
		  Success := True;
	       exception
		  when others =>
		     --Text_Io.Put("Exception in defcon 2");
		     raise;			   
	       end;		     		  				 
				    
	       
	       
	    else
	       
	       Gtk_New(Search_Dialog, "Search Paramaters...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
	       Set_Deletable(Search_Dialog, False);
	       Search_Cancel := Gtk.Dialog.Add_Button(Search_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
	       Search_Ok := Gtk.Dialog.Add_Button(Search_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
	       Set_Position(Search_Dialog, Win_Pos_Center);
	       
	       Vbox := Get_Content_area(Search_Dialog);
	       Gtk_New_hbox(Charge_Hbox);
	       Gtk_New(Charge_Label, "Charge max : ");
	       Gtk_New(Charge, Charge_Spin_min, Charge_Spin_max, Charge_Spin_step);
	       Pack_Start(Charge_Hbox, Charge_Label, False, False, 2);
	       Pack_Start(Charge_Hbox, Charge, False, False, 2);
	       Pack_Start(Vbox, Charge_Hbox, False, False, 0);
	       
	       Gtk_New_hbox(Max_Hbox);
	       Gtk_New(Max_Label, "Max missiles : ");
	       Gtk_New(Max_Entry);
	       Set_Text(Max_Entry, "1");
	       Pack_Start(Max_Hbox, Max_Label, False, False, 2);
	       Pack_Start(Max_Hbox, Max_Entry, False, False, 2);
	       Pack_Start(Vbox, Max_Hbox, False, False, 0);

	       Show_All(Search_Dialog);	    
	       
	       case Gtk.Dialog.Run(Search_Dialog) is	    	    
		  when Gtk.Dialog.Gtk_Response_Ok =>
		     begin
			Target_Max := Positive'Value(Get_Text(Max_Entry));
			Charge_Max := Charge_Type(Get_Value(Charge));
			Gtk.Dialog.Destroy(Search_Dialog);
			
			if not Weapon_Manager.Is_Empty(To_Pointer(Main_Window).Wopr.enemy) then
			   
			   
			   declare
			      
			      The_Weapons_Units : array (1..Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Enemy)) of Missile_Unit_Type;
			      Unit_Hbox : Gtk_Hbox;
			      Lat_Label : Gtk_Label;
			      Lon_Label : Gtk_Label;
			      Scrolled  : Gtk_Scrolled_window;
			      Units_Vbox : Gtk_Vbox;
			      Armament_Frame : Gtk_Frame;
			   begin
			      
			      Gtk_New(Armament_Dialog, "Missiles position validation...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
			      Set_Default_Size (Armament_dialog, 1024, 240);
			      Set_Deletable(Armament_Dialog, False);
			      Armament_Cancel := Gtk.Dialog.Add_Button(Armament_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
			      Armament_Ok := Gtk.Dialog.Add_Button(Armament_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
			      Set_Position(Armament_Dialog, Win_Pos_Center);
			      
			      Vbox := Get_Content_area(Armament_Dialog);		  
			      Gtk_New (Scrolled);
			      Set_Policy (Scrolled, Policy_Automatic, Policy_Automatic);
			      Pack_Start(Vbox, Scrolled);
			      Gtk_New_Vbox(Units_Vbox);
			      Gtk_New(Armament_Frame);
			      Add_With_viewport(Scrolled, Armament_frame);
			      Add(Armament_Frame, Units_Vbox);
			      
			      for Index in The_Weapons_Units'Range loop
				 declare
				    Missile : Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Enemy, Index);
				    Buffer : constant Gps_Coordonates_Type := Missile.Position;
				 begin
				    Missile.Position:= Missile.Target;
				    Missile.Target := Buffer;

				    
				    Gtk_New(Lat_Label, "Latitude  :");
				    Gtk_New(Lon_Label, "Longitude :");
				    Gtk_New(Charge_Label, "Charge max : ");
				    Gtk_New_Hbox(Unit_Hbox);  			
				    Gtk_New(The_Weapons_Units(Index).Degr_Lat, -90.0, 90.0, 1.0);
				    Set_Value(The_Weapons_Units(Index).Degr_Lat, Gdouble(Missile.Position.Latitude.Degr_Lat));
				    Gtk_New(The_Weapons_Units(Index).Degr_Lon, -180.0, 180.0, 1.0);		     
				    Set_Value(The_Weapons_Units(Index).Degr_lon, Gdouble(Missile.Position.Longitude.Degr_lon));
				    Gtk_New(The_Weapons_Units(Index).Minu_Lat, 0.0, 60.0, 1.0);
				    Set_Value(The_Weapons_Units(Index).minu_Lat, Gdouble(Missile.Position.Latitude.minu_Lat));
				    Gtk_New(The_Weapons_Units(Index).Seco_Lat, 0.0, 60.0, 1.0);		     
				    Set_Value(The_Weapons_Units(Index).seco_Lat, Gdouble(Missile.Position.Latitude.seco_Lat));
				    Gtk_New(The_Weapons_Units(Index).Minu_Lon, 0.0, 60.0, 1.0);
				    Set_Value(The_Weapons_Units(Index).minu_lon, Gdouble(Missile.Position.Longitude.minu_lon));
				    Gtk_New(The_Weapons_Units(Index).Seco_Lon, 0.0, 60.0, 1.0);
				    Set_Value(The_Weapons_Units(Index).seco_lon, Gdouble(Missile.Position.Longitude.seco_lon));
				    
				    Pack_Start(Unit_Hbox, Lat_Label);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Degr_lat);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Minu_lat);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Seco_lat);
				    Pack_Start(Unit_Hbox, Lon_Label);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Degr_Lon);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Minu_Lon);
				    Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Seco_Lon);
				    
				    Gtk_New_hbox(Charge_Hbox);
				    Gtk_New(The_Weapons_Units(Index).Charge, Charge_Spin_min, Charge_Spin_max, Charge_Spin_step);				    
				    Set_Value(The_Weapons_Units(Index).Charge, Gdouble(Charge_Max));
				    Pack_Start(Charge_Hbox, Charge_Label, False, False, 2);
				    Pack_Start(Charge_Hbox, The_Weapons_Units(Index).Charge, False, False, 2);
				    Pack_Start(Unit_hbox, Charge_Hbox, False, False, 0);
				    
				    Gtk_New(The_Weapons_Units(Index).Armed_Check, "Armed");			
				    Pack_Start(unit_Hbox, The_Weapons_Units(Index).Armed_Check, False, False, 2);
				    Set_Active(The_Weapons_Units(Index).Armed_Check, Missile.Armed);
				    Set_Use_Action_Appearance(The_Weapons_Units(Index).Armed_Check, True);
				    Pack_Start(Units_Vbox, Unit_hbox);						

				 end;
				 exit when Index = Target_Max;
			      end loop;
			      
			      
			      ----Text_Io.Put_Line("show_all");
			      
			      Show_All(Vbox);
			      
			      case Gtk.Dialog.Run(Armament_Dialog) is	    	    
				 when Gtk.Dialog.Gtk_Response_Ok =>		     		     		     
				    
				    declare
				       Temp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;		
				       Count : Natural := 0;
				    begin
				       for Index in The_Weapons_Units'range loop
					  
					  declare
					     Missile : Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Enemy, Index);
					     Buffer : constant Gps_Coordonates_Type := Missile.Position;
					  begin
					     Missile.Position:= Missile.Target;
					     Missile.Target := Buffer;
					     
					     if get_active(The_Weapons_Units(Index).Armed_Check) then
						
						Missile.Position.Latitude.Degr_Lat := Latitude_Degree_Type(Get_Value(The_Weapons_Units(Index).Degr_Lat));
						
						Missile.Position.Longitude.Degr_Lon := Longitude_Degree_Type(Get_Value(The_Weapons_Units(Index).Degr_lon));
						
						Missile.Position.Latitude.Minu_Lat := Latitude_Minute_Type(Get_Value(The_Weapons_Units(Index).minu_Lat));
						
						Missile.Position.Latitude.Seco_Lat := Latitude_Second_Type(Get_value(The_Weapons_Units(Index).seco_Lat));
						
						Missile.Position.Longitude.Minu_Lon := Longitude_Minute_Type(Get_Value(The_Weapons_Units(Index).minu_lon));
						
						Missile.Position.Longitude.Seco_Lon := Longitude_Second_Type(Get_Value(The_Weapons_Units(Index).seco_lon));
						
						Missile.Charge := Charge_Type(Get_Value(The_Weapons_Units(Index).Charge));
						
						Temp := Temp & Missile;
						Count := Count + 1;
					     end if;
					     
					  end;
					  exit when count = Target_Max;
				       end loop;
				       Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Weapons);
				       To_Pointer(Main_Window).Wopr.Weapons := To_Pointer(Main_Window).Wopr.Weapons & Temp;
				       To_Pointer(Main_Window).Defensive_Missiles := Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons));
				       
				    end;				    
				    
				    begin						
				       Gtk.Dialog.Destroy(Armament_Dialog);
				       declare
					  
					  
					  task Deamon is
					  end Deamon;
					  
					  task body Deamon is				    
					  begin
					     
					     null; -- Defensive Armament -- target validation (list charge per missile);	    
					     Norad.Wopr.armament(To_Pointer(Main_Window).Wopr, Success);	    						
					     
					     --Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);
					     					     
					     delay Deamon_delay;
					     Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
					  end Deamon;	       
				       begin
					  Show_All(Wait_Dialog);
					  case Gtk.Dialog.Run(Wait_Dialog) is
					     when others =>
						Gtk.Dialog.Destroy(Wait_Dialog);
					  end case;
				       end;
				       
				       

				    exception
				       when others =>
					  null;			   
				    end;		     		  				 
				 when others =>
				    Gtk.Dialog.Destroy(Armament_Dialog);		  
				    
				    
			      end case;			
			   end;
			end if;
		     end;
		  when others =>
		     Gtk.Dialog.Destroy(search_Dialog);
		     
		     
	       end case;      
	       Success := True;
	    end if;	    	    	    
	    
	    Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :" & Charge_Type'Image(To_Pointer(Main_Window).Wopr.Charge));
	    Draw_weapons(To_Pointer(Main_Window));	    
	    Draw_enemy(To_Pointer(Main_Window));
	 when 3 =>
			    
	    
	    
	    Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_3.png");
	    
	    declare
	       
	       
	       task Deamon is
	       end Deamon;
	       
	       task body Deamon is
		  
	       begin
		  null; -- Enemy acquisition -- network request (missiles list);
		  Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Enemy);
		  Norad.Wopr.Enemy_Acquisition(To_Pointer(Main_Window).Wopr, Success);		  
		  
		  declare
		     Tmp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;		
		  begin
		     if not Is_Empty(To_Pointer(Main_Window).Wopr.Enemy) then
			for Index in 1..Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Enemy) loop
			   declare
			   Missile : constant Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Enemy, index);
			   begin
			      if Side_Of(Missile.Position) /= Side_Of(To_Pointer(Main_Window).Wopr.GPS_Coordonates) then			     
			      Insert(Tmp, Last_Index(Tmp) + 1,  Missile);
			      end if;
			   end;
			end loop;
			Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Enemy);
			To_Pointer(Main_Window).Wopr.Enemy := Tmp; 
			To_Pointer(Main_Window).Enemy_missiles := Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.enemy));
		     end if;
		  end;
		     
		  delay Deamon_delay;
		  Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
	       end Deamon;	       
	    begin
	       Show_All(Wait_Dialog);                        
	       case Gtk.Dialog.Run(Wait_Dialog) is
		  when others =>
		     Gtk.Dialog.Destroy(Wait_Dialog);
	       end case;
	    end;
	    	    
	    Success := True;
	    Draw_enemy(To_Pointer(Main_Window));
	    
	 when 4 =>
	    
	    
	    Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_4.png");
	    
	    if (To_Pointer(Main_Window).Wopr.Self_Autorized and To_Pointer(Main_Window).Self_Is_Set) and then
	      To_Pointer(Main_Window).Automation.Full_Automation then	       
		     
	       begin						
		  
		  declare
		     
		     
		     task Deamon is
		     end Deamon;
		     
		     task body Deamon is				    
		     begin
			null; -- Offensive Armament -- target validation (missiles list);	    
			Norad.Wopr.Armament(To_Pointer(Main_Window).Wopr, Success);	    
			To_Pointer(Main_Window).Offensive_Missiles := Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons));			
			delay Deamon_delay;
			Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
		     end Deamon;	       
		  begin
		     Show_All(Wait_Dialog);
		     case Gtk.Dialog.Run(Wait_Dialog) is
			when others =>
			   Gtk.Dialog.Destroy(Wait_Dialog);
		     end case;
		  end;
		  
		  
		  
	       exception
		  when others =>
		     null;			   
	       end;		     		  
	       
	       Success := True;
	       
	    else
	       
	       
	       if Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons) /= 0 then
			
			
		  declare
		     
		     The_Weapons_Units : array (1..Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons)) of Missile_Unit_Type;
		     Unit_Hbox : Gtk_Hbox;
		     Lat_Label : Gtk_Label;
		     Lon_Label : Gtk_Label;
		     Scrolled  : Gtk_Scrolled_window;
		     Units_Vbox : Gtk_Vbox;
		     Armament_Frame : Gtk_Frame;
		  begin
		     
		     Gtk_New(Armament_Dialog, "Missiles targets validation...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
		     Set_Default_Size (Armament_dialog, 1024, 240);
		     Set_Deletable(Armament_Dialog, False);
		     Armament_Cancel := Gtk.Dialog.Add_Button(Armament_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
		     Armament_Ok := Gtk.Dialog.Add_Button(Armament_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
		     Set_Position(Armament_Dialog, Win_Pos_Center);
		     
		     Vbox := Get_Content_area(Armament_Dialog);		  
		     Gtk_New (Scrolled);
		     Set_Policy (Scrolled, Policy_Automatic, Policy_Automatic);
		     Pack_Start(Vbox, Scrolled);
		     Gtk_New_Vbox(Units_Vbox);
		     Gtk_New(Armament_Frame);
		     Add_With_viewport(Scrolled, Armament_frame);
		     Add(Armament_Frame, Units_Vbox);
		     
		     for Index in The_Weapons_Units'Range loop
			declare
			   Missile : constant Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Weapons, Index);
			begin
			   Gtk_New(Lat_Label, "Latitude  :");
			   Gtk_New(Lon_Label, "Longitude :");
			   Gtk_New(Charge_Label, "Charge max : ");		  
			   Gtk_New_Hbox(Unit_Hbox);		     			
			   Gtk_New(The_Weapons_Units(Index).Degr_Lat, -90.0, 90.0, 1.0);
			   Set_Value(The_Weapons_Units(Index).Degr_Lat, Gdouble(Missile.target.Latitude.Degr_Lat));
			   Gtk_New(The_Weapons_Units(Index).Degr_Lon, -180.0, 180.0, 1.0);		     
			   Set_Value(The_Weapons_Units(Index).Degr_lon, Gdouble(Missile.target.Longitude.Degr_lon));
			   Gtk_New(The_Weapons_Units(Index).Minu_Lat, 0.0, 60.0, 1.0);
			   Set_Value(The_Weapons_Units(Index).minu_Lat, Gdouble(Missile.target.Latitude.minu_Lat));
			   Gtk_New(The_Weapons_Units(Index).Seco_Lat, 0.0, 60.0, 1.0);		     
			   Set_Value(The_Weapons_Units(Index).seco_Lat, Gdouble(Missile.target.Latitude.seco_Lat));
			   Gtk_New(The_Weapons_Units(Index).Minu_Lon, 0.0, 60.0, 1.0);
			   Set_Value(The_Weapons_Units(Index).minu_lon, Gdouble(Missile.target.Longitude.minu_lon));
			   Gtk_New(The_Weapons_Units(Index).Seco_Lon, 0.0, 60.0, 1.0);
			   Set_Value(The_Weapons_Units(Index).seco_lon, Gdouble(Missile.target.Longitude.seco_lon));
			   
			   Pack_Start(Unit_Hbox, Lat_Label);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Degr_lat);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Minu_lat);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Seco_lat);
			   Pack_Start(Unit_Hbox, Lon_Label);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Degr_Lon);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Minu_Lon);
			   Pack_Start(Unit_Hbox, The_Weapons_Units(Index).Seco_Lon);
			   
			   Gtk_New_hbox(Charge_Hbox);
			   Gtk_New(The_Weapons_Units(Index).Charge, Charge_Spin_min, Charge_Spin_max, Charge_Spin_step);
			   Set_Value(The_Weapons_Units(Index).Charge, Gdouble(Missile.Charge));
			   Pack_Start(Charge_Hbox, Charge_Label, False, False, 2);
			   Pack_Start(Charge_Hbox, The_Weapons_Units(Index).Charge, False, False, 2);
			   Pack_Start(Unit_hbox, Charge_Hbox, False, False, 0);
			   
			   Gtk_New(The_Weapons_Units(Index).Armed_Check, "Armed");			
			   Pack_Start(unit_Hbox, The_Weapons_Units(Index).Armed_Check, False, False, 2);
			   Set_Active(The_Weapons_Units(Index).Armed_Check, Missile.Armed);
			   Set_Use_Action_Appearance(The_Weapons_Units(Index).Armed_Check, True);
			   Pack_Start(Units_Vbox, Unit_hbox);						
			end;
		     end loop;
		     
		     ----Text_Io.Put_Line("show_all");
		     Show_All(Vbox);
		     
		     
		     case Gtk.Dialog.Run(Armament_Dialog) is	    	    
			when Gtk.Dialog.Gtk_Response_Ok =>		     		     		     
			   
			   declare
			      Temp : Weapon_Manager.Vector := Weapon_Manager.Empty_Vector;		
			   begin
			      
			      for Index in The_Weapons_Units'Range loop
				 
				 declare
				    Missile : Missile_Type := Weapon_Manager.Element(To_Pointer(Main_Window).Wopr.Weapons, Index);
				 begin
				    
				    if get_active(The_Weapons_Units(Index).Armed_Check) then
				       Missile.Target.Latitude.Degr_Lat := Latitude_Degree_Type(Get_Value(The_Weapons_Units(Index).Degr_Lat));
				       
				       Missile.Target.Longitude.Degr_Lon := Longitude_Degree_Type(Get_Value(The_Weapons_Units(Index).Degr_lon));
				       
				       Missile.Target.Latitude.Minu_Lat := Latitude_Minute_Type(Get_Value(The_Weapons_Units(Index).minu_Lat));
				       
				       Missile.Target.Latitude.Seco_Lat := Latitude_Second_Type(Get_value(The_Weapons_Units(Index).seco_Lat));
				       
				       Missile.Target.Longitude.Minu_Lon := Longitude_Minute_Type(Get_Value(The_Weapons_Units(Index).minu_lon));
				       
				       Missile.Target.Longitude.Seco_Lon := Longitude_Second_Type(Get_Value(The_Weapons_Units(Index).seco_lon));
				       
				       Missile.Charge := Charge_Type(Get_Value(The_Weapons_Units(Index).Charge));
				       
				       Temp := Temp & missile;				       				       
				    end if;
				 end;
			      end loop;			      
			      Weapon_Manager.Clear(To_Pointer(Main_Window).Wopr.Weapons);
			      To_Pointer(Main_Window).Wopr.Weapons := To_Pointer(Main_Window).Wopr.Weapons & Temp;
			      
			   end;				    
			   
			   begin						
			      Gtk.Dialog.Destroy(Armament_Dialog);
			      declare
				 
				 
				 task Deamon is
				 end Deamon;
				 
				 task body Deamon is				    
				 begin
				    null; -- Offensive Armament -- target validation (missiles list);	    
				    Norad.Wopr.Armament(To_Pointer(Main_Window).Wopr, Success);	    
				    To_Pointer(Main_Window).Offensive_Missiles := Natural(Weapon_Manager.Last_Index(To_Pointer(Main_Window).Wopr.Weapons));
				    delay Deamon_delay;
				    Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
				 end Deamon;	       
			      begin
				 Show_All(Wait_Dialog);
				 case Gtk.Dialog.Run(Wait_Dialog) is
				    when others =>
				       Gtk.Dialog.Destroy(Wait_Dialog);
				 end case;
			      end;
			      
			      
			      
			   exception
			      when others =>
				 null;			   
			   end;		     		  
			   
			when others =>
			   Gtk.Dialog.Destroy(Armament_Dialog);		  


		     end case;	       
		  end;
	       end if;
	       Success := True;
	    end if;
	    --Norad.Wopr.Get(To_Pointer(Main_Window).Wopr, Success);	    
	    Clear(To_Pointer(Main_Window).Canvas);
	    Draw_Wopr_With_population(To_Pointer(Main_Window));
	    Draw_weapons(To_Pointer(Main_Window));	    
	    
	    Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :" & Charge_Type'Image(To_Pointer(Main_Window).Wopr.Charge));
      	 when 5 =>      	    	    
	    
	    Set(To_Pointer(Main_Window).Defcon_Image, "data/images/defcon_5.png");	    
	    if (To_Pointer(Main_Window).Wopr.Self_Autorized and To_Pointer(Main_Window).Self_Is_Set) and then
	      To_Pointer(Main_Window).Automation.Full_Automation then
	       
	       
	       begin
		  
		  Charge_Max := To_Pointer(Main_Window).Automation.Charge_Max_Per_missile;
		  Target_Max := Natural((To_Pointer(Main_Window).Wopr.Charge/Charge_max)/100.0 * (Long_Float(To_Pointer(Main_Window).Automation.Offensive_Strategy)));
		  
		  declare
		     
		     
		     task Deamon is
		     end Deamon;
		     
		     task body Deamon is
			
		     begin
			null; -- Traget Searching -- Algorithm parameters (Charge per missile, max_missiles);	    
			Norad.Wopr.Target_Search(To_Pointer(Main_Window).Wopr, Success, Charge_Max, Target_max);
			delay Deamon_delay;
			Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
		     end Deamon;	       
		  begin
		     
		     Show_All(Wait_Dialog);
		     case Gtk.Dialog.Run(Wait_Dialog) is
			when others =>
			   Gtk.Dialog.Destroy(Wait_Dialog);
		     end case;
		  end;
		  

		  
	       exception
		  when others =>
		     null;			   
	       end;		     		  
	       
	       Success := True;
	       
	    else
	       Gtk_New(Search_Dialog, "Search Paramaters...", Gtk_Window(To_Pointer(Main_Window)), Gtk.dialog.modal);
	       Set_Deletable(Search_Dialog, False);
	       Search_Cancel := Gtk.Dialog.Add_Button(Search_Dialog, "Cancel", Gtk.Dialog.Gtk_Response_Cancel);
	       Search_Ok := Gtk.Dialog.Add_Button(Search_Dialog, "Ok", Gtk.Dialog.Gtk_Response_Ok);
	       Set_Position(Search_Dialog, Win_Pos_Center);
	       
	       Vbox := Get_Content_area(Search_Dialog);
	       Gtk_New_hbox(Charge_Hbox);
	       Gtk_New(Charge_Label, "Charge max : ");
	       Gtk_New(Charge, Charge_Spin_min, Charge_Spin_max, Charge_Spin_step);
	       Pack_Start(Charge_Hbox, Charge_Label, False, False, 2);
	       Pack_Start(Charge_Hbox, Charge, False, False, 2);
	       Pack_Start(Vbox, Charge_Hbox, False, False, 0);
	       
	       Gtk_New_hbox(Max_Hbox);
	       Gtk_New(Max_Label, "Max missiles : ");
	       Gtk_New(Max_Entry);
	       Set_Text(Max_Entry, "1");
	       Pack_Start(Max_Hbox, Max_Label, False, False, 2);
	       Pack_Start(Max_Hbox, Max_Entry, False, False, 2);
	       Pack_Start(Vbox, Max_Hbox, False, False, 0);

	       Show_All(Search_Dialog);	    
	       
	       case Gtk.Dialog.Run(Search_Dialog) is	    	    
		  when Gtk.Dialog.Gtk_Response_Ok =>
		     begin
			Target_Max := Positive'Value(Get_Text(Max_Entry));
			Charge_Max := Charge_Type(Get_Value(Charge));
			
			Gtk.Dialog.Destroy(Search_Dialog);
			
			declare
			   
			   
			   task Deamon is
			   end Deamon;
			   
			   task body Deamon is
			      
			   begin
			      null; -- Traget Searching -- Algorithm parameters (Charge per missile, max_missiles);	    
			      Norad.Wopr.Target_Search(To_Pointer(Main_Window).Wopr, Success, Charge_Max, Target_max);
			      delay Deamon_delay;
			      Gtk.Dialog.response(Wait_Dialog, Gtk.Dialog.Gtk_Response_Cancel);
			   end Deamon;	       
			begin
			   Show_All(Wait_Dialog);
			   case Gtk.Dialog.Run(Wait_Dialog) is
			      when others =>
				 Gtk.Dialog.Destroy(Wait_Dialog);
			   end case;
			end;
			
		
			
		     exception
			when others =>
			   null;			   
		     end;		     		  
		     
		  when others =>
		     Gtk.Dialog.Destroy(Search_Dialog);		  
	       end case;
	       
	       Success := True;      	 
	    end if;
	    Draw_weapons(To_Pointer(Main_Window));
      end case;
      
      if not Success then
	 Game_Over(To_Pointer(Main_Window));	       	       
      else	       	    	       	 	 	 
	 Set_Text(To_Pointer(Main_Window).Destroyed_Wopr_Label, "Destroyed WOPR    : " & Natural'Image(To_Pointer(Main_Window).Wopr.Destroyed_Wopr));
	 Set_Text(To_Pointer(Main_Window).Earned_missiles_Label, "Earned Missiles        : " & Natural'Image(To_Pointer(Main_Window).Wopr.Earned_Missiles));
	 Set_Text(To_Pointer(Main_Window).Destroyed_Missiles_Label, "Destroyed Missiles  : " & Natural'Image(To_Pointer(Main_Window).Wopr.Destroyed_Missiles));      
	 
	 Set_Text(To_Pointer(Main_Window).Attack_Missiles_Label, "Offensive Missiles  : " & Natural'Image(To_Pointer(Main_Window).Offensive_Missiles));
	 Set_Text(To_Pointer(Main_Window).Enemy_missiles_Label, "Enemy Missiles       : " & Natural'Image(To_Pointer(Main_Window).Enemy_Missiles));
	 Set_Text(To_Pointer(Main_Window).Defense_missiles_Label, "Defense Missiles    : "& Natural'Image(To_Pointer(Main_Window).Defensive_Missiles));
	 Set_Text(To_Pointer(Main_Window).Total_Charge_Label,    "Total charge :" & Charge_Type'Image(To_Pointer(Main_Window).Wopr.Charge));
      end if;
      if (To_Pointer(Main_Window).Wopr.Self_Autorized and To_Pointer(Main_Window).Self_Is_Set) then
	 case Alert is
	    when 1 =>
	       To_Pointer(Main_Window).Current_Lertcon := 5;
	    when others =>
	       To_Pointer(Main_Window).Current_Lertcon := To_Pointer(Main_Window).Current_Lertcon - 1;
	 end case;
      end if;
      
   end LertCon;   
   
   -- Constant UI Manager define --
   Entries : constant Action_Entry_Array :=
     (1 => Create (Name => "GameMenu",        Label => "_Game"),      
      2 => Create (Name => "Start",
                   Stock_Id    => Stock_New,
                   Label       => "_Start",
                   Accelerator => "<control>S",
                   Tooltip     => "Start a new game",
                   Callback    => Start_New_Game'Access),
      3 => Create (Name => "Quit",
		   Stock_Id    => Stock_Quit,
		   Label       => "_Quit",
		   Accelerator => "<control>Q",
		   Tooltip     => "Quit",
		   Callback    => Main_Quit'Access),		   
      4 => Create (Name => "ZoomMenu",
		   Label => "_Zoom"),      
      5 => Create (Name => "ZoomIn",
		   Stock_Id    => STOCK_ZOOM_IN,
		   Label       => "Zoom In",
		   Accelerator => "<control>P",
		   Tooltip     => "ZoomIn",
		   Callback    => Zoom_in'Access),
      6 => Create (Name => "ZoomOut",
		   Stock_Id    => STOCK_ZOOM_OUT,
		   Label       => "Zoom Out",
		   Accelerator => "<control>M",
		   Tooltip     => "ZoomOut",
		   Callback    => Zoom_out'Access),
      7 => Create (Name => "NetworkMenu",
		   Label => "_Network"),      
      8 => Create (Name => "Login",
		   Stock_Id    => Stock_Connect,
		   Label       => "Log In",
		   Accelerator => "<control>I",
		   Tooltip     => "Login",
		   Callback    => Login'Access),
      9 => Create (Name => "Logout",
		   Stock_Id    => Stock_Disconnect,
		   Label       => "Log Out",
		   Accelerator => "<control>O",
		   Tooltip     => "LogOut",
		   Callback    => Logout'Access),
      10 => Create (Name => "AlgoMenu",
		    Label => "_Algorithm"),      
      11 => Create (Name => "Linear",
		   Stock_Id    => Stock_refresh,
		   Label       => "Linear",
		   Accelerator => "<control>L",
		   Tooltip     => "Linear",
		    Callback    => Set_algo'Access),
      12 => Create (Name => "Random",
		    Stock_Id    => Stock_refresh,
		    Label       => "Random",
		   Accelerator => "<control>R",
		   Tooltip     => "Random",
		    Callback    => Set_Algo'Access),
      13 => Create (Name => "AlertMenu",
		   Label => "_LertCon"),      
      14 => Create (Name => "Defcon_1",
		    Stock_Id    => "", -- "defcon_1",
		    Label       => "Defcon 1",
		    Accelerator => "<function>F1",
		    Tooltip     => "Defcon_1",
		    Callback    => LertCon'Access),
      15 => Create (Name => "Defcon_2",
		    Stock_Id    => "", -- "defcon_2",
		    Label       => "Defcon 2",
		   Accelerator => "<function>F2",
		   Tooltip     => "Defcon_2",
		    Callback    => LertCon'Access),
      16 => Create (Name => "Defcon_3",
		    Stock_Id    => "", -- "defcon_3",
		    Label       => "Defcon 3",
		   Accelerator => "<function>F3",
		   Tooltip     => "Defcon_3",
		   Callback    => LertCon'Access),
      17 => Create (Name => "Defcon_4",
		   Stock_Id    => "", -- "defcon_4",
		   Label       => "Defcon 4",
		   Accelerator => "<function>F4",
		   Tooltip     => "Defcon_4",
		    Callback    => LertCon'Access),
      18 => Create (Name => "Defcon_5",
		    Stock_Id    => "", -- "defcon_5",
		    Label       => "Defcon 5",
		    Accelerator => "<function>F5",
		    Tooltip     => "Defcon_5",
		    Callback    => LertCon'Access),
      19 => Create (Name => "ModeMenu",
		    Label => "_Mode"),      
      20 => Create (Name => "Computer",
		    Stock_Id    => "", -- "Computer",
		    Label       => "Computer",
		    Accelerator => "<control>C",
		    Tooltip     => "Computer",
		    Callback    => Automation_install'Access),
      21 => Create (Name => "Human",
		    Stock_Id    => "", -- "Human",
		    Label       => "Human",
		    Accelerator => "<control>H",
		    Tooltip     => "Human",
		    Callback    => Automation_remove'Access),
      22 => Create (Name => "HelpMenu",
		    Label => "_Help"),      
      23 => Create (Name => "About",
		    Stock_Id    => "", -- "About",
		    Label       => "About",
		    Accelerator => "<function>F11",
		    Tooltip     => "About",
		    Callback    => About'Access),
      24 => Create (Name => "License",
		    Stock_Id    => "", -- "License",
		    Label       => "License",
		    Accelerator => "<function>F12",
		    Tooltip     => "License",
		    Callback    => License'Access)
     );
   
      
   UI_Info : constant String :=
     "<ui>"
     & "  <menubar name='MenuBar'>"
     & "    <menu action='GameMenu'>"
     & "      <menuitem action='Start'/>"     
     & "      <separator/>"
     & "      <menuitem action='Quit'/>"
     & "    </menu>"
     & "    <menu action='NetworkMenu'>"
     & "      <menuitem action='Login'/>"
     & "      <menuitem action='Logout'/>"
     & "    </menu>"
     & "    <menu action='ModeMenu'>"
     & "      <menuitem action='Computer'/>"
     & "      <menuitem action='Human'/>"
     & "    </menu>"     
     & "    <menu action='AlgoMenu'>"
     & "      <menuitem action='Linear'/>"
     & "      <menuitem action='Random'/>"
     & "    </menu>"
     & "    <menu action='AlertMenu'>"
     & "      <menuitem action='Defcon_1'/>"
     & "      <menuitem action='Defcon_2'/>"
     & "      <menuitem action='Defcon_3'/>"
     & "      <menuitem action='Defcon_4'/>"
     & "      <menuitem action='Defcon_5'/>"
     & "    </menu>"
     & "    <menu action='ZoomMenu'>"
     & "      <menuitem action='ZoomIn'/>"
     & "      <menuitem action='ZoomOut'/>"
     & "    </menu>"
     & "    <menu action='HelpMenu'>"
     & "      <menuitem action='About'/>"
     & "      <menuitem action='License'/>"
     & "    </menu>"     
     & "  </menubar>"
     & "</ui>";
   
   
   
  
   ---------------
   -- Draw_Grid --
   ---------------

   --  procedure Draw_Grid
   --    (Canvas : access Image_Canvas_Record;
   --     Cr     : Cairo.Cairo_Context) is
   --  begin
   --     if Canvas.Draw_Grid then
   --        Draw_Grid (Interactive_Canvas_Record (Canvas.all)'Access, Cr);
   --     end if;
   --  end Draw_Grid;
   
   -- Variable Canvas define.
   
   Layout : Pango_Layout;
   --Green_Gc : Gdk.GC.Gdk_GC;
   
   
   
   -- Sub functions Implementations.
   
   ---------------------------
   -- Draw_To_Double_Buffer --
   ---------------------------
   --  procedure Draw_To_Double_Buffer (Item : access Display_Item_Record'Class) is
   --  begin
   --     Set_Foreground (Green_Gc, Display_Item (Item).Color);
   --     Draw_Rectangle
   --       (Pixmap (Item),
   --        GC     => Green_Gc,
   --        Filled => True,
   --        X      => 0,
   --        Y      => 0,
   --        Width  => Item.W,
   --        Height => Item.H);
   --     Set_Foreground (Green_Gc, Black (Get_Default_Colormap));

   --     Set_Text (Layout, "Item" & Positive'Image (Display_Item (Item).Num));
   --     Draw_Layout
   --       (Pixmap (Item),
   --        Green_Gc,
   --        10,
   --        10,
   --        Layout);

   --     Draw_Shadow
   --       (Style       => Get_Style (Item.Canvas),
   --        Window      => Pixmap (Item),
   --        State_Type  => State_Normal,
   --        Shadow_Type => Shadow_Out,
   --        X           => 0,
   --        Y           => 0,
   --        Width       => Item.W,
   --        Height      => Item.H);

   --     --  We could not make Draw_To_Double_Buffer a primitive operation, since
   --     --  it is defined in the body, however it would be cleaner in a real
   --     --  application
   --     --  if Item.all in Hole_Item_Record'Class then
   --     --     Draw_Shadow
   --     --       (Style       => Get_Style (Item.Canvas),
   --     --        Window      => Pixmap (Item),
   --     --        State_Type  => State_Normal,
   --     --        Shadow_Type => Shadow_Etched_Out,
   --     --        X           => Get_Coord (Item).Width / 2 - 12,
   --     --        Y           => Get_Coord (Item).Height / 2 - 12,
   --     --        Width       => 24,
   --     --        Height      => 24);
   --     --  end if;
   --  end Draw_To_Double_Buffer;

   --  procedure Draw (Item : access Display_Item_Record'Class) is
   --     begin
   --     Set_Foreground (Green_Gc, Display_Item (Item).Color);
   --     Draw_Rectangle
   --       (Pixmap (Item),
   --        GC     => Green_Gc,
   --        Filled => True,
   --        X      => 0,
   --        Y      => 0,
   --        Width  => Item.W,
   --        Height => Item.H);
   --     Set_Foreground (Green_Gc, Black (Get_Default_Colormap));

   --     --Set_Text (Layout, "Wopr");
   --     Draw_Layout
   --       (Pixmap (Item),
   --        Green_Gc,
   --        5,
   --        5,
   --        Layout);

   --     Draw_Shadow
   --       (Style       => Get_Style (Item.Canvas),
   --        Window      => Pixmap (Item),
   --        State_Type  => State_Normal,
   --        Shadow_Type => Shadow_Out,
   --        X           => 0,
   --        Y           => 0,
   --        Width       => Item.W,
   --        Height      => Item.H);


   --  end Draw;

   procedure Draw
     (Item   : access Display_Item_Record;
      Cr     : Cairo_Context)
   is
   begin
      Gdk.Cairo.Set_Source_Color (Cr, Item.Color);
      Cairo.Rectangle
        (Cr, 0.5, 0.5, Gdouble (Item.W) - 1.0, Gdouble (Item.H) - 1.0);
      Cairo.Fill (Cr);

      Gdk.Cairo.Set_Source_Color (Cr, Item.Title);
      Rectangle
        (Cr, 0.5, 0.5, Gdouble (Item.W) - 1.0, Gdouble (Item.H) - 1.0);
      Cairo.Stroke (Cr);

      Set_Text (Layout, "Item" & Positive'Image (Display_Item (Item).Num));
      Cairo.Move_To (Cr, 10.0, 10.0);
      Pango.Cairo.Show_Layout (Cr, Layout);
   end Draw;
   
   ---------------------
   -- Item initialize --
   ---------------------
   
   ----------------
   -- Initialize --
   ----------------
   --  --  procedure Initialize_Wopr(Xborg : Xborg_Application;
   --  --  			     Item   : access Display_Item_Record'Class);
   --  procedure Initialize
   --    (Item   : access Display_Item_Record'Class;
   --     Canvas : access Interactive_Canvas_Record'Class;
   --     Color  : in Color_Type) is

      
   --  begin
   --     Item.Canvas := Interactive_Canvas (Canvas);
   --     Item.Color := Colors (color);
   --     Item.W := 7;
   --     Item.H := 7;
   --     Item.Num := 1;
   --     --  Xborg.Items_List (Item.Num) := Canvas_Item (Item);
   --     --  Xborg.Num := Xborg.Num + 1;
   --     Set_Screen_Size (Item, Item.W, Item.H);
   --     Draw_To_Double_Buffer (Item);
   --  end Initialize;

   procedure Initialize
     (Item   : access Display_Item_Record'Class;
      Canvas : access Interactive_Canvas_Record'Class;
      Color  : in Color_Type) is
   begin
      Item.Canvas := Interactive_Canvas (Canvas);
      Item.Color := Colors (color);
      --Item.Title := Get_Black (Get_Default_Style);
      Item.Num := 1;
      --  if Last_Item <= Items_List'Last then
      --     Items_List (Item.Num) := Canvas_Item (Item);
      --  end if;
      -- Last_Item := Last_Item + 1;
      Set_Screen_Size (Item, Item.W, Item.H);
      --Set_Text (Num_Items_Label, Positive'Image (Last_Item - 1) & " items");
   end Initialize;

   
   
   procedure Initialize_Wopr (Item   : access Display_Item_Record'Class;
			      Canvas : access Interactive_Canvas_Record'Class) is
   begin
      Item.W := 5;
      Item.H := 5;
      Initialize (Item, Canvas, 2);
   end Initialize_Wopr;
   
   
   procedure Initialize_populations (Item   : access Display_Item_Record'Class;
				    Canvas : access Interactive_Canvas_Record'Class) is
   begin
      Item.W := 5;
      Item.H := 5;
      Initialize (Item, Canvas, 10);
   end Initialize_Populations;
   
   procedure Initialize_target (Item   : access Display_Item_Record'Class;
				Canvas : access Interactive_Canvas_Record'Class) is
   begin
      Item.W := 4;
      Item.H := 4;
      Initialize (Item, Canvas, 13);
   end Initialize_Target;
   
   procedure Initialize_Missile (Item   : access Display_Item_Record'Class;
				 Canvas : access Interactive_Canvas_Record'Class) is
   begin
      Item.W := 5;
      Item.H := 5;
      Initialize (Item, Canvas, 1);
   end Initialize_Missile;

   
   procedure Initialize_enemy (Item   : access Display_Item_Record'Class;
			       Canvas : access Interactive_Canvas_Record'Class) is
   begin
      Item.W := 5;
      Item.H := 5;
      Initialize (Item, Canvas, 11);
   end Initialize_Enemy;
   
   
   
   
   ------------------------
   -- Item add functions --
   ------------------------
   
   --  ---------------------
   --  -- Add_Single_Item --
   --  ---------------------

   --  procedure Add_Single_Item
   --    (Canvas : access Interactive_Canvas_Record'Class;      
   --     With_Link : Boolean;
   --     X      : Gint;
   --     Y      : Gint)
   --  is
   --     Item : constant Display_Item := new Display_Item_Record;
   --     Num  : constant Positive := 1;
   --  begin
   --     Initialize (Item, Canvas);
      
   --     Put (Canvas, Item, x, y);
   --     Refresh_Canvas (Canvas);
   --     Show_Item (Canvas, Item);
   --  end Add_Single_Item;
   
   --  -------------------------------
   --  -- Add_Single_Item_With_Link --
   --  -------------------------------

   --  procedure Add_Single_Item_With_Link
   --    (Canvas : access Interactive_Canvas_Record'Class;
   --     X      : Gint;
   --     Y      : Gint) is
   --  begin
   --     Add_Single_Item (Canvas, True, X, Y);
   --  end Add_Single_Item_With_Link;

   --  -----------------------------
   --  -- Add_Single_Item_No_Link --
   --  -----------------------------
   
   --  procedure Add_Single_Item_No_Link
   --    (Canvas : access Interactive_Canvas_Record'Class;
   --     X      : Gint;
   --     Y      : Gint) is
   --  begin
   --     Add_Single_Item (Canvas, False, X, Y);
   --  end Add_Single_Item_No_Link;
   
   
   ---------------------
   -- Add_Canvas_Link --
   ---------------------
   
   procedure Add_Canvas_Link
     (Canvas : access Interactive_Canvas_Record'Class;
      Item1, Item2 : access Canvas_Item_Record'Class; Text : String := "")
   is
      Link : constant Canvas_Link := new Canvas_Link_Record;
   begin
      Add_Link (Canvas, Link, Item1, Item2, Both_Arrow, Text);
      --Last_Link := Last_Link + 1;
      --Set_Text (Num_Links_Label, Positive'Image (Last_Link - 1) & " links");
   end Add_Canvas_Link;


   
   
   
   -----------------
   --   Gtk_New   --
   -----------------

   
   procedure Gtk_New(Main_Window : out Main_Window_Type) is
   begin
      Main_Window := new Main_Window_Record_Type;
      Xborg.Initialize(Main_Window);
   end Gtk_New;
   
   

   -------------
   -- Zoom_In --
   -------------
   
   procedure Zoom_In (Action, Main_Window : System.Address) is
      --Act : constant Gtk_Action := Gtk.Action.Convert (Action);                  
   begin
      Zoom_In(To_pointer(Main_Window).Canvas);
   end Zoom_In;

   
   procedure Zoom_In
     (Canvas : access Interactive_Canvas_Record'Class) is
   begin
      for J in Zoom_Levels'First .. Zoom_Levels'Last - 1 loop
         if Zoom_Levels (J) = Get_Zoom (Canvas) then
            Zoom (Canvas, Zoom_Levels (J + 1), 0.2);
         end if;
      end loop;
   end Zoom_In;
   
   
   --------------
   -- Zoom_Out --
   --------------
   
   procedure Zoom_Out (Action, Main_Window : System.Address) is
      --Act : constant Gtk_Action := Gtk.Action.Convert (Action);                  
   begin
      Zoom_Out(To_pointer(Main_Window).Canvas);
   end Zoom_Out;
   
   procedure Zoom_Out
     (Canvas : access Interactive_Canvas_Record'Class) is
   begin
      for J in Zoom_Levels'First + 1 .. Zoom_Levels'Last loop
         if Zoom_Levels (J) = Get_Zoom (Canvas) then
            Zoom (Canvas, Zoom_Levels (J - 1), 0.2);
         end if;
      end loop;
   end Zoom_Out;

   
   ---------------------
   -- Draw_Background --
   ---------------------
   --     procedure Draw_Background
   --    (Canvas        : access Image_Canvas_Record;
   --     Screen_Rect   : Gdk.Rectangle.Gdk_Rectangle)
   --  is
   --     X_Left : constant Glib.Gint := Left_World_Coordinates (Canvas);
   --     Y_Top  : constant Glib.Gint := Top_World_Coordinates (Canvas);
   --  begin
   --     if Canvas.Background /= null then
   --        --  This is slightly complex, since we need to properly handle zooming
   --        --  and tiling.
   --        declare
   --           X, Y, W, H, Ys : Gint;
   --           Xs : Gint := Screen_Rect.X;
   --           Bw : constant Gint := Get_Width (Canvas.Background)
   --             * Gint (Get_Zoom (Canvas)) / 100;
   --           Bh : constant Gint := Get_Height (Canvas.Background)
   --             * Gint (Get_Zoom (Canvas)) / 100;
   --           Scaled : Gdk_Pixbuf := Canvas.Background;
   --        begin
   --           --  A real application would cache this scaled pixmap, and update
   --           --  the cache when the "zoomed" signal is emitted.
   --           if Get_Zoom (Canvas) /= 100 then
   --              Scaled := Scale_Simple (Canvas.Background, Bw, Bh);
   --           end if;

   --           while Xs < Screen_Rect.X + Screen_Rect.Width loop
   --              Ys := Screen_Rect.Y;
   --              X := (X_Left + Xs) mod Bw;
   --              W := Gint'Min (Screen_Rect.Width + Screen_Rect.X - Xs, Bw - X);

   --              while Ys < Screen_Rect.Y + Screen_Rect.Height loop
   --                 Y := (Y_Top  + Ys) mod Bh;
   --                 H := Gint'Min
   --                   (Screen_Rect.Height + Screen_Rect.Y - Ys, Bh - Y);

   --                 Render_To_Drawable
   --                   (Pixbuf       => Scaled,
   --                    Drawable     => Get_Window (Canvas),
   --                    Gc           => Get_Black_GC (Get_Style (Canvas)),
   --                    Src_X        => X,
   --                    Src_Y        => Y,
   --                    Dest_X       => Xs,
   --                    Dest_Y       => Ys,
   --                    Width        => W,
   --                    Height       => H);
   --                 Ys := Ys + H;
   --              end loop;
   --              Xs := Xs + W;
   --           end loop;

   --           if Get_Zoom (Canvas) /= 100 then
   --              Unref (Scaled);
   --           end if;
   --        end;

   --     else
   --        Draw_Rectangle
   --          (Get_Window (Canvas),
   --           Get_Background_GC (Get_Style (Canvas), State_Normal),
   --           Filled => True,
   --           X      => Screen_Rect.X,
   --           Y      => Screen_Rect.Y,
   --           Width  => Gint (Screen_Rect.Width),
   --           Height => Gint (Screen_Rect.Height));
   --     end if;
   --     if Canvas.Draw_Grid then
   --        Draw_Grid (Interactive_Canvas (Canvas), Canvas.Grid_GC, Screen_Rect);
   --     end if;
   --  end Draw_Background;
   
   
   
   --  procedure Draw_Background
   --    (Canvas : access Image_Canvas_Record;
   --     Cr     : Cairo.Cairo_Context)
   --  is
   --  begin
   --     if Canvas.Background /= Null_Pattern then
   --        Cairo.Save (Cr);
   --        Cairo.Set_Source (Cr, Canvas.Background);
   --        Cairo.Paint (Cr);
   --        Cairo.Restore (Cr);
   --     else
   --        Cairo.Save (Cr);
   --        Gdk.Cairo.Set_Source_Color
   --          (Cr, Get_Bg (Get_Style (Canvas), State_Normal));
   --        Cairo.Paint (Cr);
   --        Cairo.Restore (Cr);
   --     end if;
   --  end Draw_Background;
   
   Bg_Image : constant String := "data/images/world-map-1.1.png";
   
   procedure Draw_Background
     (Canvas : access Image_Canvas_Record;
      Cr     : Cairo.Cairo_Context)
   is
      Surface    : Cairo.Cairo_Surface;
      Background : Cairo.Cairo_Pattern;
   begin
      Surface := Cairo.Png.Create_From_Png (Bg_Image);
      
      Background := Cairo.Pattern.Create_For_Surface (Surface);
      
      Cairo.Pattern.Set_Extend (Canvas.Background, Cairo_Extend_None);
      
      --Destroy(Surface);
      
      Cairo.Save (Cr);
      
      Cairo.Set_Source (Cr, Canvas.Background);
      
      Cairo.Paint (Cr);
      
      Cairo.Restore (Cr);
      
   end Draw_Background;
   
   
   -----------------
   -- Initialize  --
   -----------------         
   
   procedure Initialize(Main_Box : access Main_Box_Record_Type'Class) is
      
   begin
      Gtk.Box.Initialize_vbox(Main_Box, Homogeneous => False, Spacing => 0);
      
      Gtk_New_Hbox(Main_Box.Top_Hbox);
      
      Pack_Start (Gtk_Vbox(Main_Box), Main_Box.Top_Hbox, Expand => False, Fill => False);
      
      Gtk_New_Hbox(Main_Box.Mid_Hbox);
      Gtk_New_Hbox(Main_Box.Bot_Hbox);
      
      
      Pack_Start (Gtk_Vbox(Main_Box), Main_Box.Mid_Hbox, Expand => False, Fill => False);
      Pack_Start (Gtk_Vbox(Main_Box), Main_Box.Bot_Hbox, Expand => False, Fill => False);
   end Initialize;

   procedure Initialize(Main_Window : in Main_Window_Type) is
      
      -- UI Manager define.
      Error   : aliased GError := null;
                  
      
      
      
      -- Canvas define.      
      Scrolled : Gtk_Scrolled_Window;      
      Frame    : Gtk_Frame;
      
      
      -- Cairo define
      Surface : Cairo_Surface;
      Style   : Gtk_Style;
      
                  
   begin
      
      
      
      Gtk.Window.Initialize (Main_Window, Gtk.Enums.Window_Toplevel);
      Set_title (Main_Window, "Warborg - Xborg 2015");
      Set_Default_Size (Main_Window, 1280, 500);
      Set_Position(Main_Window, Win_Pos_Center);
      --Set_Resizable(Main_Window, False);
      Window_Cb.Connect (Main_Window, "destroy",
                         Window_Cb.To_Marshaller (Exit_Main'Access));
      Return_Window_Cb.Connect
        (Main_Window, "delete_event",
         Return_Window_Cb.To_Marshaller (Delete_Event'Access));
      
      --  Creating Main Box --
      Main_Window.Main_VBox := new Main_Box_Record_Type;     
      initialize(Main_Window.Main_Vbox);      
      Add (Main_Window, Gtk.Box.Gtk_Vbox(Main_Window.Main_Vbox));
      
      
      -- Creating UI Manager --
      
      Gtk_New (Main_Window.Actions, "Actions");
      Add_Actions (Main_Window.Actions, Entries, To_Address(Main_Window));
      Gtk_New (Main_Window.UI);
      Insert_Action_Group (Main_Window.UI, Main_Window.Actions, 0);
      Add_Accel_Group
        (Gtk_Window(Main_Window), Get_Accel_Group (Main_Window.UI));
      
      if Add_UI_From_String (Main_Window.UI, UI_Info, Error'Unchecked_Access) = 0 then
         --Put_Line ("Building menus failed: " & Get_Message (Error));
         Error_Free (Error);
      end if;      
      
      -- Perform UI install.
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Logout")), false);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Start")), False);    
      Set_Sensitive(Get_Action(Main_Window.Actions, ("ModeMenu")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("AlgoMenu")), False);      
      Set_Sensitive(Get_Action(Main_Window.Actions, ("AlertMenu")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_1")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_2")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_3")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_4")), False);
      Set_Sensitive(Get_Action(Main_Window.Actions, ("Defcon_5")), False);
      -- Add UI in Main_Vbox.Top_Hbox --
      Pack_Start (Main_Window.Main_Vbox.Top_Hbox, Get_Widget (Main_Window.UI, "/MenuBar"), False, False, 5);
      
      
      
      -- Creating Log left_vbox at left of Main_Window.Main_Vbox.Mid_HBox
      
      Gtk_New_Vbox(Main_Window.Left_Vbox);
      Pack_start (Main_Window.Main_Vbox.Mid_Hbox, Main_Window.Left_Vbox, False, False, 5);
      
      Gtk_New (Main_Window.Progress_Bar);
      --Configure (Main_Window.Progress_Bar, 1.0, 1.0, 100.0);
      --  for I in 1..100 loop
      --  	 Set_fraction(Main_Window.Progress_Bar, 1.0);
      --  end loop;
      --Set_Format_String (Main_Window.Progress_Bar, "%v from [%l,%u] (=%p%%)");
      
      Pack_start(Main_Window.Left_Vbox, Main_Window.Progress_Bar, False, False, 5);
      
      -- Defcon frame --
      Gtk_New(Main_Window.Defcon_Frame, "Alert Condition");
      Pack_Start(Main_Window.Left_Vbox, Main_Window.Defcon_Frame, False, True, 5);
      Gtk_New(Main_Window.Defcon_Image);      
      Set(Main_Window.Defcon_Image, "data/images/defcon_5.png");
      Add(Main_Window.Defcon_Frame, Main_Window.Defcon_Image);                  
      
      
      -- Populations frame --
      Gtk_New(Main_Window.Populations_Frame, "Populations");
      Gtk_New_Vbox(Main_Window.Populations_Vbox);
      Add(Main_Window.Populations_Frame, Main_Window.Populations_Vbox);      
      Gtk_New(Main_Window.Populations_Ouest_Label, "");      
      Gtk_New(Main_Window.Populations_Est_Label, "");      
      Pack_Start(Main_Window.Populations_Vbox, Main_Window.Populations_Ouest_Label, False, False, 2);
      Pack_Start(Main_Window.Populations_Vbox, Main_Window.Populations_Est_Label, False, False, 2);
      Pack_start(Main_Window.Left_Vbox, Main_Window.Populations_Frame, False, False, 5);
	    
            
      
      Gtk_New(Scrolled);
      Gtk_New(Frame);
      Add(Frame, Scrolled);
      Gtk_New(Main_Window.Nation_Text);
      Set_Size_Request(Main_Window.Nation_Text, 128, 240);
      Set_Editable(Main_Window.Nation_Text, False);
      Add(Scrolled, Main_Window.Nation_Text);      
      Pack_start(Main_Window.left_Vbox, Frame, False, False, 5);
      
      
      
      --  frame --
      --  Gtk_New(Main_Window.Frame, "Caption");
      --  Pack_Start(Main_Window.Left_Vbox, Main_Window.Frame, False, True, 5);
      --  Gtk_New(Main_Window.Image);      
      --  Set(Main_Window.Image, "data/images/legend-2015.png");
      --  Add(Main_Window.Frame, Main_Window.Image);                  
      
      
      
      
      -- Creating Canvas --
      Gtk_New (Frame);      
      Set_Size_Request(Frame, Gint(Max_X_Coordonate)+50, Gint(Max_Y_Coordonate)+70);
      Add (Main_Window.Main_Vbox.Mid_Hbox, frame);
      
      Gtk_New (Scrolled);
      Set_Policy (Scrolled, Policy_Automatic, Policy_Automatic);
      
      Add(Frame, Scrolled);
      Main_Window.Canvas := new Image_Canvas_Record;
                  
      Gtkada.Canvas.Initialize (Main_Window.Canvas);
      --Set_Size_request(Main_Window.Canvas, Gint(Max_X_Coordonate)+50, Gint(Max_Y_Coordonate)+70);
      --Set_Size_request(Main_Window.Canvas, 800, 600);
      Add (Scrolled, Main_Window.Canvas);
      
      -- Initialize Background --
      --  Gdk_New_From_File
      --    (Main_Window.Canvas.Background,
      --     Filename => "data/images/world-map-1.1.jpg",
      --     Error    => Error);
      Surface :=
	Cairo.Png.Create_From_Png ("data/images/world-map-1.1.png");
      Main_Window.Canvas.Background :=
	Cairo.Pattern.Create_For_Surface (Surface);
      Cairo.Pattern.Set_Extend
	(Main_Window.Canvas.Background, Cairo_Extend_pad);
      Destroy (Surface);
      
      Style := Get_Default_Style;
      --  Set_Bg
      --  	(Style, State_Normal, Gdk_Color'(Get_Light (Style, State_Prelight)));
      --  Set_Fg
      --  	(Style, State_Normal, Gdk_Color'(Get_Black (Style)));
      Set_Style (Main_Window.Canvas, Style);
      
      Realize (Main_Window.Canvas);
      
      --  Initialize the colors

      --Gdk_New (Green_Gc, Get_Window (Main_Window.Canvas));
      --  for J in Color_Names'Range loop
      --     Colors (J) := Parse (Color_Names (J).all);
      --     Alloc (Gtk.Widget.Get_Default_Colormap, Colors (J));
      --  end loop;
      
      for J in Color_Names'Range loop
         --Parse (Colors (J), Color_Names (J).all, Success);
	 Colors (J) := Parse (Color_Names (J).all);
      end loop;

      
      
      Layout := Create_Pango_Layout (Main_window);            
      
      -- Make Main_Window.Main_Vbox.Bot_Hbox
      
      -- Points frame --
      Gtk_New(Main_Window.Points_Frame, "Points");
      Gtk_New_Vbox(Main_Window.Points_Vbox);
      Gtk_New(Main_Window.Destroyed_Wopr_Label, "");
      Gtk_New(Main_Window.Earned_missiles_Label, "");
      Gtk_New(Main_Window.Destroyed_Missiles_Label, "");
      Pack_Start(Main_Window.Points_Vbox, Main_Window.Destroyed_Wopr_Label, False, true);
      Pack_Start(Main_Window.Points_Vbox, Main_Window.Earned_Missiles_Label, False, true);
      Pack_Start(Main_Window.points_Vbox, Main_Window.Destroyed_Missiles_Label, False, True);            
      
      Add(Main_Window.Points_Frame, Main_Window.Points_Vbox);
      Pack_start(Main_Window.Main_Vbox.bot_Hbox, Main_Window.Points_Frame, False, False, 5);
      
      
      
      -- Log frame --
      Gtk_New(Main_Window.Log_Frame, "Log");
      Gtk_New_Vbox(Main_Window.Log_Vbox);      
      Add(Main_Window.Log_Frame, Main_Window.Log_Vbox);
      
      Gtk_New(Main_Window.Attack_Missiles_Label, "");
      Gtk_New(Main_Window.Enemy_missiles_Label, "");
      Gtk_New(Main_Window.Defense_missiles_Label, "");
      Pack_Start(Main_Window.Log_Vbox, Main_Window.Attack_Missiles_Label, False, True);                                   
      Pack_Start(Main_Window.Log_Vbox, Main_Window.Enemy_missiles_Label, False, True);      
      Pack_Start(Main_Window.Log_Vbox, Main_Window.Defense_Missiles_Label, False, True);      
      
            
      Pack_start(Main_Window.Main_Vbox.bot_Hbox, Main_Window.log_Frame, False, False, 5);
      
	  

      
      Gtk_New(Main_Window.Weapons_Frame, "Weapons");
      Gtk_New_Vbox(Main_Window.Weapons_Vbox);      
      Add(Main_Window.Weapons_Frame, Main_Window.Weapons_Vbox);
      
      Gtk_New(Main_Window.Total_Charge_Label, "");
      Gtk_New(Main_Window.Charge_missiles_Label, "");
      Gtk_New(Main_Window.Strategy_label, "");
      Pack_Start(Main_Window.Weapons_Vbox, Main_Window.Total_Charge_Label, False, True);                                   
      Pack_Start(Main_Window.Weapons_Vbox, Main_Window.Charge_missiles_Label, False, True);      
      Pack_Start(Main_Window.Weapons_Vbox, Main_Window.Strategy_label, False, True);      
      
      
      Pack_start(Main_Window.Main_Vbox.bot_Hbox, Main_Window.weapons_Frame, False, False, 5);
      
      
	  
      -- Call Show_All (main_vbox).
      
      Show_All(Gtk.Box.Gtk_Vbox(Main_Window.Main_Vbox));      
   end Initialize;   
   
end Warborg.Xborg;
