with Gtk.Text_Buffer;     use Gtk.Text_Buffer;
with Gtk.Text_view;                          use Gtk.Text_view;

with Gtk.Dialog;                        use Gtk.Dialog;
with Gtk.Spin_Button;                   use Gtk.Spin_Button;

with Gtk.Label;                         use Gtk.Label;
with Gtk.Frame;                         use Gtk.Frame;
with Gtk.Image;                         use Gtk.Image;

with Gtk.Progress_Bar;    use Gtk.Progress_Bar;

with Cairo;               use Cairo;

with Glib;                              
with Gdk.Color;                         use Gdk.Color;
with System.Address_To_Access_Conversions;

with Gtk.Window;
with Gtk.Box;                           use Gtk.Box;
with Gtk.Main;
with Glib.Main;                         

with Gtkada.Canvas;       use Gtkada.Canvas;
--with Gdk.GC;              use Gdk.GC;

with Gtk.UI_Manager;                    use Gtk.UI_Manager;
with Gtk.Action_Group;                  use Gtk.Action_Group;
package Warborg.Xborg is
   
   pragma Elaborate_Body(Warborg.Xborg);
   
   type Main_Box_Record_Type is new Gtk.Box.Gtk_Vbox_Record with
      record
	 Top_Hbox : Gtk.Box.Gtk_Hbox;
	 Mid_Hbox : Gtk.Box.Gtk_Hbox;
	 Bot_Hbox : Gtk.Box.Gtk_Hbox;
      end record;
   
   type Main_Box_Type is access all Main_Box_Record_Type'Class;
   procedure Initialize(Main_Box : access Main_Box_Record_Type'Class);   

   type Wopr_Attributes_Window is
      record
         Dialog : Gtk_dialog;

         Degr_Lat : Gtk_Spin_Button;
         Minu_Lat : Gtk_Spin_Button;
         Seco_Lat : Gtk_Spin_Button;
         Degr_Lon : Gtk_Spin_Button;
         Minu_Lon : Gtk_Spin_Button;
         Seco_Lon : Gtk_Spin_Button;
         Lat_Hbox : Gtk_Hbox;
         Lon_Hbox : Gtk_Hbox;

         Lat_Label: Gtk_Label;
         Lon_Label : Gtk_Label;

         Main_Vbox : Gtk_Vbox;
      end record;

   
   type Image_Canvas_Record is new Interactive_Canvas_Record with private;
   
   type Image_Canvas is access all Image_Canvas_Record'Class;
   
   
   subtype Per_Cent_Type is Float range 1.0..100.0;
   type Automation_Parameters_Type is
      record
	 Offensive_Strategy : Per_Cent_Type := 50.0;
	 Charge_Max_Per_Missile : Charge_Type := 0.001;
	 Full_Automation : Boolean := False;
      end record;
   
   
   
   
   type Main_Window_Record_Type is new Gtk.Window.Gtk_Window_Record with
      record
	 
	 UI         : Gtk_UI_Manager;
	 Actions    : Gtk_Action_Group;      
	       
	 Main_Vbox  : Main_Box_Type;	 
	 Canvas     : Image_Canvas;
	 
	 
	 Left_Vbox : Gtk_Vbox;
	 Progress_Bar : Gtk_Progress_Bar;
	 Defcon_Frame               : Gtk_Frame;
	 Defcon_Image               : Gtk_Image;
	 
	 Frame               : Gtk_Frame;
	 Image               : Gtk_Image;
	 
	 
	 Populations_Frame           : Gtk_Frame;
	 Populations_Vbox            : Gtk_Vbox;
	 Populations_Ouest_Label     : Gtk_Label;
	 Populations_Est_Label       : Gtk_Label;
	 
	 Points_Frame               : Gtk_Frame;
         Points_Vbox                : Gtk_Vbox;
         Earned_Missiles_Label      : Gtk_Label;
         Destroyed_Wopr_Label       : Gtk_Label;
	 Destroyed_Missiles_label   : Gtk_Label; 
	 
	 Log_Frame                  : Gtk_Frame;
         Log_Vbox                   : Gtk_Vbox;
	 Attack_Missiles_Label      : Gtk_Label; 
	 Enemy_Missiles_label       : Gtk_Label; 
	 Defense_Missiles_label     : Gtk_Label; 
	 Offensive_Missiles : Natural := 0;
	 Enemy_Missiles     : Natural := 0;
	 Defensive_Missiles  : Natural := 0;
	 
	 
	 Weapons_Frame               : Gtk_Frame;
         Weapons_Vbox                : Gtk_Vbox;
         Total_Charge_Label          : Gtk_Label;
         Charge_missiles_Label       : Gtk_Label;
	 Strategy_label              : Gtk_Label; 
	 
	 
	 
	 Ouest_Population : Long_Long_Integer := 0;
	 Est_Population    : Long_Long_Integer := 0;	 
	 Wopr                       : Wopr_Type;
	 Wopr_Window                : Wopr_Attributes_Window;
	 Timeout_Id                 : Glib.Main.G_Source_Id;
	 Self_Is_Set                : Boolean := False;
	 Current_Lertcon            : Lertcon_Type := 1;
	 Automation                 : Automation_Parameters_Type;
	 
	 
	 
	 Nation_Buffer              : Gtk_Text_Buffer;
	 Nation_Text                : Gtk_Text_view;
	 
	 
	 
	 
	 
	 
	 
	 
      end record;
   package Main_Window_Conversion is new System.Address_To_Access_Conversions(Main_Window_Record_Type);
   use Main_Window_Conversion;
   

   subtype Main_Window_Type is Object_Pointer;
   procedure Gtk_New(Main_Window : out Main_Window_Type);
   procedure Initialize(Main_Window : in Main_Window_Type);
private   
         
   type Image_Canvas_Record is new Interactive_Canvas_Record with 
      record
	 --Background : Gdk_Pixbuf;
	 Background : Cairo_Pattern := Null_Pattern;
	 Draw_Grid  : Boolean := False;
	 --Grid_GC    : Gdk_GC;
      end record;
   
   -- Sub functions Specifications.
   --  procedure Draw_Background
   --    (Canvas        : access Image_Canvas_Record;
   --     Screen_Rect   : Gdk.Rectangle.Gdk_Rectangle);

   procedure Draw_Background
     (Canvas : access Image_Canvas_Record;
      Cr     : Cairo.Cairo_Context);
   --  Draw the background image

   
   -- Constant Canvas define.   
   
   
   Max_Colors : constant := 20;

   type String_Access is access String;
   
   type Color_Type is range 1 .. Max_Colors;
   
   Color_Names : constant array (Color_Type) of String_Access :=
     (new String'("forest green"),
      new String'("red"),
      new String'("blue"),
      new String'("yellow"),
      new String'("peach puff"),
      new String'("azure"),
      new String'("seashell"),
      new String'("lavender"),
      new String'("grey"),
      new String'("turquoise"),
      new String'("khaki"),
      new String'("tan"),
      new String'("orange red"),
      new String'("MediumPurple"),
      new String'("ivory1"),
      new String'("DeepSkyBlue1"),
      new String'("burlywood1"),
      new String'("wheat1"),
      new String'("orange1"),
      new String'("pink"));
   
   Colors : array (Color_Type) of Gdk_Color;
   
   Zoom_Levels : constant array (Positive range <>) of Glib.Gdouble :=
     (0.15, 0.40, 0.65, 0.85, 1.0, 1.2, 1.35, 1.60, 2.0, 2.5);
     --  Zoom_Levels : constant array (Positive range <>) of Guint :=
     --    (15, 40, 65, 85, 100, 120, 135, 160, 200, 250);
   
   
   
   
      ----------------------------------------------------------------
   --  Redefine our own item type, since we want to provide our own
   --  graphics.
   ----------------------------------------------------------------
   
   type Display_Item_Record is new Buffered_Item_Record with record
      Canvas : Interactive_Canvas;
      Color  : Gdk.Color.Gdk_Color;
      Title  : Gdk.Color.Gdk_Color;
      W, H   : Glib.Gint;
      Num    : Positive;
   end record;
   type Display_Item is access all Display_Item_Record'Class;
         
   procedure Initialize
     (Item   : access Display_Item_Record'Class;
      Canvas : access Interactive_Canvas_Record'Class;
      Color  : in Color_Type);
   --  Initialize Item with a random size and color.
   --  Canvas must have been realized
   
   --procedure Draw (Item : access Display_Item_Record'Class);
   procedure Draw
     (Item   : access Display_Item_Record;
      Cr     : Cairo_Context);
   --  Draw the item to the double-buffer
   
   
   
   Max_X_Coordonate : Float := 1024.0;
   Max_y_Coordonate : Float := 768.0;
   
   
   
   subtype Map_X_Coordonate_Type is float range 0.0..Max_X_Coordonate;
   subtype Map_Y_Coordonate_Type is float range 0.0..Max_Y_Coordonate;
   
   Lon_Unit : constant Float := Float'Rounding((Max_X_Coordonate/(360.0*60.0*60.0)) * 1000000.0) / 1000000.0;
   Lat_Unit : constant Float := Float'Rounding((Max_Y_Coordonate/(180.0*60.0*60.0)) * 1000000.0) / 1000000.0;
   
   
   type Map_Coordonates_Type is
      record
         X : Map_X_Coordonate_Type := 0.0;
         Y : Map_Y_Coordonate_Type := 0.0;
      end record;      
   
   function To_Map_Coordonates(GPS_Coordonates : in Gps_Coordonates_Type) return Map_Coordonates_Type;

   
end Warborg.Xborg;
