with Ada.Numerics.Elementary_Functions;
use Ada.Numerics.Elementary_Functions;

with Ada.Text_Io;

with Ada.Float_Text_Io;

with Interfaces.C;
use Interfaces.C;

package body Warborg is
   
   -- GPS define --
   
   type Double_Access is access all Double;
   
   function Modf (X : in Double; Iptr : in Double_access) return Double;
   pragma Import(C, Modf, "modf");
   function To_GPS(Decimal_longitude : in Decimal_Longitude_Type;
		   Decimal_Latitude  : in Decimal_Latitude_Type)  return GPS_Coordonates_Type is
      
      GPS_Coordonates : GPS_Coordonates_Type;
      Longitude : Longitude_Coordonate_Type;
      Latitude  : Latitude_Coordonate_Type;
      
      Local : Double := 0.0;
      
      Degree_Int : constant Double_Access := new Double ' (0.0);      
      Minute_Flo : Double := 0.0;
      Minute_Int : constant Double_Access := new Double ' (0.0);      
      Second_flo : Double := 0.0;      
            
      
   begin
      
      -- Longitude convertion
      --
      Local := Double(Decimal_Longitude);
      if Decimal_Longitude < 0.0 then
      	 local := local * (-1.0);
      end if;
                  
      Minute_Flo := 60.0 * Modf(Local, Degree_Int);            
      
      Second_Flo := 60.0 * Modf(Minute_Flo, Minute_int);
      
      if Decimal_Longitude < 0.0 then
	 Degree_Int.all := Degree_Int.all * (-1.0);

      end if;            
      Longitude.Degr_Lon := Float(Degree_Int.all);
      Longitude.Minu_Lon := Float(Minute_Int.all);
      Longitude.Seco_Lon := Float(Second_Flo);
      
           
      Local := Double(Decimal_Latitude);
      if Decimal_Latitude < 0.0 then
      	 local := local * (-1.0);
      end if;
      
      
      Minute_Flo := 60.0 * Modf(Local, Degree_Int);            
      
      Second_Flo := 60.0 * Modf(Minute_Flo, Minute_int);
      
      
      -- Latitude convertion
      if Decimal_Latitude < 0.0 then
	 Degree_Int.all := Degree_Int.all * (-1.0);

      end if;            
      Latitude.Degr_Lat := Float(Degree_Int.all);
            
      
      Latitude.Minu_Lat := Float(Minute_Int.all);
      
      
      Latitude.Seco_Lat := Float(Second_Flo);

      
      GPS_Coordonates := (Longitude, Latitude);
      return GPS_Coordonates;
   end To_GPS;         
   
   procedure Print (GPS_Coordonates : GPS_Coordonates_Type) is
      Longitude : constant Longitude_Coordonate_Type := GPS_Coordonates.Longitude;
      Latitude  : constant Latitude_Coordonate_Type := GPS_Coordonates.Latitude;
   begin
      Text_Io.Put("Long ");
      Float_Text_Io.Put(Longitude.Degr_Lon, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Longitude.Minu_Lon, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Longitude.Seco_Lon, 2, 0, 0);Text_Io.Put('"');
      Text_Io.Put(", Lat ");
      Float_Text_Io.Put(Latitude.Degr_Lat, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Latitude.Minu_Lat, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Latitude.Seco_Lat, 2, 0, 0);Text_Io.Put('"');
      Text_Io.New_Line;
   end Print;
   

   function Longitude (X : in Longitude_Coordonate_Type) return Decimal_Longitude_Type is	 	 	 
   begin
      
      if X.Degr_Lon < 0.0 then
	 return -Decimal_Longitude_Type(abs(X.Degr_Lon) + (abs(X.Minu_Lon) / 60.0) + (abs(X.Seco_Lon) / 3600.0));
      else
	    return Decimal_Longitude_Type(abs(X.Degr_Lon) + (abs(X.Minu_Lon) / 60.0) + (abs(X.Seco_Lon) / 3600.0));
      end if;
   end Longitude;
   
   function latitude (Y : in Latitude_Coordonate_Type) return Decimal_Latitude_Type is
   begin
      
      if Y.Degr_Lat < 0.0 then
	 return -Decimal_Latitude_Type(abs(Y.Degr_Lat) + (abs(Y.Minu_Lat) / 60.0) + (abs(Y.Seco_Lat) / 3600.0));
      else
	 return Decimal_Latitude_Type(abs(Y.Degr_Lat) + (abs(Y.Minu_Lat) / 60.0) + (abs(Y.Seco_Lat) / 3600.0));
      end if;	      
   end Latitude;
      
      
   function Is_in(Target : in Gps_Coordonates_Type; item : in Gps_Coordonates_Type; Distance : in Float) return Boolean is
            
      		 	      
      --  Formule À Appliquer Pour Calculer Une Orthodromie : Cos P = (Sin LA . Sin LB) + (Cos LA . Cos LB . Cos G)      
      LA, LB, G: Float := 0.0;
      P : Float := 0.0;
      --    LA Correspond À La Latitude Du Point A.
      --    LB Correspond À La Latitude Du Point B.
      --    G Correspond À La Différence De Longitude Entre Le Point A Et Le Point B.       
      Cos_Produit : Float := 0.0;
      sin_Produit : Float := 0.0;
      Sum_Produit : Float := 0.0;
   begin   
      
      La := Float'Rounding(Latitude(Target.Latitude) * 10000.0) / 10000.0;
      
      Lb := Float'Rounding(Latitude(Item.Latitude) * 10000.0) / 10000.0;
      
      G  :=  Float'Rounding(Longitude(item.Longitude) * 10000.0) / 10000.0 - Float'Rounding(Longitude(Target.Longitude) * 10000.0) / 10000.0;
      
      Cos_Produit := (Float'Rounding((Cos(La) * Cos(Lb) * Cos(G)) * 10000.0) /10000.0);
      
      sin_Produit := (Float'Rounding((Sin(La) * Sin(Lb))  * 10000.0) /10000.0);      
      
      Sum_Produit := (Float'Rounding((Cos_Produit + Sin_produit) * 10000.0) /10000.0);      

      P := Arccos(Sum_Produit);
      
      P := P * 60.0;
      
      if  P - Distance > 0.0 then
	 --Text_Io.Put_Line("False");
	 return False;
      else
	 --Text_Io.Put_Line("TRUE");
	 
	 return True;
      end if;
      
   exception
      when others =>
	 Print(Target);
	 Print(Item);
	 Text_Io.Put_Line("cos_produit"  & Float'Image(cos_produit));
	 Text_Io.Put_Line("sin_produit"  & Float'Image(sin_produit));
	 Text_Io.Put_Line("sum_produit"  & Float'Image(sum_produit));
	 Text_Io.Put_Line("P = " & Float'Image(P));
	 raise;
   end Is_in;
   

   
   
   function Side_Of(Position : in GPS_Coordonates_Type) return Side_Type is
   begin
      if Position.Longitude.Degr_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.Degr_Lon < 0.0 then
	 return Ouest;
      end if;      
      if Position.Longitude.minu_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.minu_Lon < 0.0 then
	 return Ouest;
      end if;
      if Position.Longitude.seco_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.seco_Lon < 0.0 then
	 return Ouest;
      end if;
      raise Constraint_Error;
   end Side_of;
   
   
   function "=" (Left, Right : in GPS_Coordonates_Type) return Boolean is
   begin
      return (Left.Longitude = Right.Longitude) and
	(Left.Latitude = Right.Latitude);
   end "=";
   
   
   -- Nation define --
   
   function "=" (Left, Right : in Nation_Type) return Boolean is
   begin
      return --(Left.Name = Right.Name) and
	
	(Left.Gps_Coordonates = Right.Gps_coordonates) and
	(Left.Population = Right.Population);
   end "=";
   
   
   -- Weapon define --
   function "=" (Left, Right : in Missile_Type) return Boolean is
   begin
      return (Left.Position = Right.Position) and
	(Left.Charge = Right.Charge) and
	(Left.Target = Right.Target);
   end "=";
	    
   
   
   -- User define --
   procedure Initialize(User : out User_Type;
			Name : in Logname_Type) is
      
   begin
      User.Logname := Name;
   end Initialize;
   -- Get player named "Name".
   
   procedure Set_Pass(User : in out User_Type;
		      Pass : in Message_Digest) is
   begin
      User.Passwd := Pass;
   end Set_Pass;
   -- Set password for player.
   
   function Check_Pass(User : in User_Type;
		       Pass : in Message_Digest) return Boolean is
   begin
      return User.Passwd = Pass;
   end Check_Pass;
   -- Return True is getted password is valid. False else.      

   
   
   
   
   -- WOPR define --
end Warborg;
