with Ada.Numerics.Discrete_Random;
with Ada.Numerics.Float_Random;
use Ada.Numerics;
with Text_Io;


with Ada.Strings.Fixed;
use Ada.Strings;

with Warborg;
use Warborg;
with Ada.Containers.Vectors;
procedure Test_Is_In_With_Solid_List is
   
   
   
   
   
   package Bool_Random is new Ada.Numerics.Discrete_Random(Boolean);   
   use Float_Random;

   
   package GPS_Coordonates_Manager is new Ada.Containers.Vectors(Positive, Gps_Coordonates_Type, "=");
   use GPS_Coordonates_Manager;
   
   Ray : constant Float := 6367.4445;
   
   function Solid_List (Side : in Side_Type;
			Ray : in Float;
			Distance : in Float) return GPS_Coordonates_Manager.Vector is
      
      Terra : GPS_Coordonates_Manager.Vector;
      Diametre : constant Float := Ray * 2.0;   
      Perimetre : constant Float := ((Pi * Diametre) / 1.852);
      D : constant Float := (1.0/60.0) * Distance * 2.0;
      
      Count_Of_Equator : constant Long_Long_integer := Long_Long_integer((Perimetre/Distance));
      
      Y : Decimal_Latitude_Type := -90.0 + D /2.0;
      X : Decimal_Longitude_Type := 0.0+ D / 2.0;            
   begin 
      Text_Io.Put_Line("D =" & Float'Image(D));
      Text_Io.Put_Line("count_of_equator =" & Long_Long_integer'Image(Count_Of_equator));	       	       	       
      
      case Side is	 
	 when Ouest =>
	North_est :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..I loop
		  for K in 1..Count_Of_Equator loop
		     for L in  J..K loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     
		     X := 0.0 + D/2.0;  	 	 
		     exit North_est when Y + D > 0.0;
		     Y := Y + D;						
		  end loop;
	       end loop;      
	    end loop North_est;
	    
	    Y := 90.0 - D/2.0;
	South_Est :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..I loop
		  for K in 1..Count_Of_Equator loop
		     for L in  J..K loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     
		     X := 0.0 + D/2.0;  	 	 
		     exit South_est when Y - D < 0.0;
		     Y := Y - D;						
		  end loop;
	       end loop;      
	    end loop South_Est;
	    
	    
	    
	    
	    
	 when Est =>	  	      
	    X := -180.0 + D/ 2.0;            
	North_West :
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..I loop
		  for K in 1..Count_Of_Equator loop
		     for L in  J..K loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     
		     X := -180.0 + D/2.0;  	 	 
		     exit North_west when Y + D > 0.0;
		     Y := Y + D;						
		  end loop;
	       end loop;      
	    end loop North_west;	       
	    
	    Y := 90.0 - D/2.0;
	South_west:
	    for I in 1..Count_Of_Equator/2 loop
	       for J in 1..I loop
		  for K in 1..Count_Of_Equator loop
		     for L in  J..K loop	    	    
			
			declare
			   Gps : constant Gps_Coordonates_Type := To_Gps(X, Y);
			begin	       	       
			   if Side_Of(GPS) /= Side then
			      Terra := Terra & GPS;
			      Print(Gps);
			      
			   end if;
			exception
			   when Constraint_Error =>
			      null;		     
			end;	    
			--Text_Io.Put_Line("X := " & Float'Image(X));	       	    
			exit when X + D > 180.0;
			X := X + D;
			
		     end loop;	 	 
		     --Text_Io.Put_Line("Y := " & Float'Image(Y));
		     
		     X := -180.0 + D/2.0;  	 	 
		     exit South_west when Y - D < 0.0;
		     Y := Y - D;						
		  end loop;
	       end loop;      
	    end loop South_west;	       

	    
      end case;
      
      
      return Terra;     
   end Solid_List;   
   
   
   Charge_max : float := 30.0;
   
   
   Position_Gen : Generator;
   
   use Weapon_Manager;
   
   Last_Index : positive := 1;
   
   
   Terra : GPS_Coordonates_Manager.Vector;   
   
   
   
Begin      
   --terra := Solid_list(ouest, Ray, Charge_Max) & Solid_list(ouest, Ray, Charge_max);
   --Text_Io.Put("Terra lenght : " & Natural'Image(GPS_Coordonates_Manager.Last_Index(Terra)));               
   --Text_Io.Skip_Line;
   --for Index in 1..GPS_Coordonates_Manager.Last_Index(Terra) loop
      declare
	 --Surface : constant GPS_Coordonates_Type := Element(Terra, Index);
	 Surface : constant GPS_Coordonates_Type := ((0.0, 0.0, 0.0), (0.0, 0.0, 0.0));
      begin
	 if Is_In(Surface, Surface, Charge_Max) then
	    Text_Io.Put_Line("Nk, ");
	 else
	    Text_Io.Put_Line("0k, ");
	 end if;
      end;
   --end loop;
			     
     

end Test_Is_In_With_Solid_List;
